// EmiDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include <direct.h>
#include "Bmp.h"
#include "Emi.h"
#include "EmiDlg.h"
#include "SpiUnit.h"
#include "FileNameUtil.h"
#include "Preference.h"
#include "JumpDialog.h"
#include "RenameDialog.h"
#include "SizeSettingDialog.h"
#include "HelpDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEmiDlg _CAO

CEmiDlg::CEmiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEmiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEmiDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	char cBase[_MAX_PATH];							// W[̃pX
	GetModuleFileName( NULL,cBase,_MAX_PATH );
	m_strBasePath = GetBaseDir( cBase );			// x[XpXl
	m_straFileType.Add( "BMP" );					// gp\ȃt@C^Cv
													//ialo͏Ɏgj

	m_bOnDeleteSmall	= FALSE;					// t@C폜ł͂Ȃ
	m_bDeleteImmediate = TRUE;						// 폜Ȃ
	m_bResizeWallPaperToScreenSize	= FALSE;		// ǎ̓TCYȂB
	m_bAutoRenameAtMove				= FALSE;		// ړAt@CƂɎl[

	m_strOpenWindowProgram			= "explorer";	// W̃EBhE\vO
	m_strURLProgram					= "explorer";	// URLJW̃vO
	m_strURLMemo					= "URLMemo.txt";	// URLt@C

	// TCY폜l
	m_iDeleteSmallWidth		= 320;
	m_iDeleteSmallHeight	= 240;

	// ړfBNgǂݍ
	// TrashfBNgǂݍ
	char cDefault[4096];
	memset( cDefault,0,sizeof( cDefault ) );
	char cName[_MAX_PATH ];
	memset( cName,0,sizeof( cName ) );
	// ftHg̃pX
	m_strMoveDir		= AddBSToDirName( (LPCTSTR)m_strBasePath ) + CString( "MoveDir" );
	m_strTrashDir		= AddBSToDirName( (LPCTSTR)m_strBasePath ) + CString( "TrashDir" );
	m_strCopyDir		= AddBSToDirName( (LPCTSTR)m_strBasePath ) + CString( "CopyDir" );
	m_strWallPaperDir	= AddBSToDirName( (LPCTSTR)m_strBasePath ) + CString( "WallPaperDir" );

	CString strIniFile;									// init@C̃pX
	GetModuleFileName( NULL,cBase,_MAX_PATH );
	strIniFile = GetBaseDir( cBase );
	strIniFile = AddBSToDirName( (LPCTSTR)strIniFile ) + CString( "Emi.ini" );

	GetPrivateProfileString( "Directory","MoveDir" ,(LPCTSTR)m_strMoveDir ,cName,sizeof( cName ),(LPCTSTR)strIniFile );
	m_strMoveDir = CString( cName );
	GetPrivateProfileString( "Directory","TrashDir",(LPCTSTR)m_strTrashDir,cName,sizeof( cName ),(LPCTSTR)strIniFile );
	m_strTrashDir = CString( cName );
	GetPrivateProfileString( "Directory","CopyDir" ,(LPCTSTR)m_strCopyDir ,cName,sizeof( cName ),(LPCTSTR)strIniFile );
	m_strCopyDir  = CString( cName );
	GetPrivateProfileString( "Directory","WallPaperDir",(LPCTSTR)m_strWallPaperDir,cName,sizeof( cName ),(LPCTSTR)strIniFile );
	m_strWallPaperDir = CString( cName );

	GetPrivateProfileString( "Directory","OpenWindowProgram",(LPCTSTR)m_strOpenWindowProgram,cName,sizeof( cName ),(LPCTSTR)strIniFile );
	m_strOpenWindowProgram = CString( cName );
	GetPrivateProfileString( "Directory","URLProgram",(LPCTSTR)m_strURLProgram,cName,sizeof( cName ),(LPCTSTR)strIniFile );
	m_strURLProgram = CString( cName );
	GetPrivateProfileString( "Directory","URLMemo",(LPCTSTR)m_strURLMemo,cName,sizeof( cName ),(LPCTSTR)strIniFile );
	m_strURLMemo = CString( cName );

	// TCY邩ۂ̐ݒ
	GetPrivateProfileString( "Preference","ResizeWallPaperToScreenSize"
							,"FALSE",cName , sizeof( cName )
							,(LPCTSTR)strIniFile );
	if( strcmp( cName,"TRUE" )==0 ){
		m_bResizeWallPaperToScreenSize	= TRUE;
	}

	// ړAt@CdƂɎl[邩ۂ
	GetPrivateProfileString( "Preference","AutoRenameAtMove"
							,"FALSE",cName , sizeof( cName )
							,(LPCTSTR)strIniFile );
	if( strcmp( cName,"TRUE" )==0 ){
		m_bAutoRenameAtMove	= TRUE;
	} else {
		m_bAutoRenameAtMove	= FALSE;
	}

	// KILL
	GetPrivateProfileString( "Preference","DeleteImmediate"
							,"FALSE",cName , sizeof( cName )
							,(LPCTSTR)strIniFile );
	if( strcmp( cName,"TRUE" )==0 ){
		m_bDeleteImmediate = TRUE;
	} else {
		m_bDeleteImmediate = FALSE;
	}

	// TCY폜ݒ
	int iWidth, iHeight;

	// 
	sprintf( cDefault , "%d" , this->m_iDeleteSmallWidth );
	GetPrivateProfileString( "DeleteSmall","Width",cDefault,cName , sizeof( cName ),(LPCTSTR)strIniFile );
	iWidth = atoi( cName );
	if( iWidth>0 ){ this->m_iDeleteSmallWidth = iWidth; }

	// 
	sprintf( cDefault , "%d" , this->m_iDeleteSmallHeight );
	GetPrivateProfileString( "DeleteSmall","Height",cDefault,cName , sizeof( cName ),(LPCTSTR)strIniFile );
	iHeight = atoi( cName );
	if( iHeight>0 ){ this->m_iDeleteSmallHeight = iHeight; }

	m_aSpiUnit.Release();							// SPI̔z
	m_bStretch = TRUE;								// Xgb`[h

	m_lOffsetX	= 0;								// `ItZbg
	m_lOffsetY	= 0;

	m_bLayoutReady = FALSE;							// CAEg͂܂B

}

void CEmiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEmiDlg)
	DDX_Control(pDX, IDC_CHANGEDIR, m_btnChangeDir);
	DDX_Control(pDX, IDC_FILELIST, m_lbFileList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEmiDlg, CDialog)
	//{{AFX_MSG_MAP(CEmiDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHANGEDIR, OnChangedir)
	ON_LBN_SELCHANGE(IDC_FILELIST, OnSelchangeFilelist)
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_PREFERENCE, OnPreference)
	ON_COMMAND(ID_ABOUTBOX, OnAboutbox)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(IDM_SMALL_RANGE, OnSmallRange)
	ON_COMMAND(IDM_DELETE_SMALL, OnDeleteSmall)
	ON_COMMAND(ID_VIEW_HELP, OnViewHelp)
	ON_COMMAND(IDM_DELETE_SMALL_RECURSIVE, OnDeleteSmallRecursive)
	ON_COMMAND(IDM_DELETE_SMALL_RECURSIVE_WITH_MOVE, OnDeleteSmallRecursiveWithMove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEmiDlg bZ[W nh

BOOL CEmiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	MapSPI();													// SPĨ}bv
	LoadFileList( m_strBasePath );								// t@CXg̓ǂݍ
	OnSelchangeFilelist();										// IύX𓯂
	m_bLayoutReady = TRUE;										// IuWFNgĔzunj
	LayoutObjects();											// IuWFNgĔzu

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CEmiDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CEmiDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		// fBNgۂ𒲂ׂ
		BOOL bIsDir = FALSE;
		bIsDir = IsDir();

		DrawScreen( &dc );
		if( bIsDir==TRUE ){
			DrawDirTopPicture();
		}

		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CEmiDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEmiDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	char cBuffer[ 4096 ];
	memset( cBuffer , 0 , sizeof( cBuffer ) );

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	CString strIniFile = GetIniPath();

	WritePrivateProfileString( "Directory","MoveDir"      ,(LPCTSTR)m_strMoveDir      ,(LPCTSTR)strIniFile );
	WritePrivateProfileString( "Directory","TrashDir"     ,(LPCTSTR)m_strTrashDir     ,(LPCTSTR)strIniFile );
	WritePrivateProfileString( "Directory","CopyDir"      ,(LPCTSTR)m_strCopyDir      ,(LPCTSTR)strIniFile );
	WritePrivateProfileString( "Directory","WallPaperDir" ,(LPCTSTR)m_strWallPaperDir ,(LPCTSTR)strIniFile );
	if( m_bResizeWallPaperToScreenSize==TRUE ){
		WritePrivateProfileString( "Preference","ResizeWallPaperToScreenSize" ,"TRUE" ,(LPCTSTR)strIniFile );
	} else {
		WritePrivateProfileString( "Preference","ResizeWallPaperToScreenSize" ,"FALSE" ,(LPCTSTR)strIniFile );
	}
	if( m_bAutoRenameAtMove==TRUE ){
		WritePrivateProfileString( "Preference","AutoRenameAtMove" ,"TRUE" ,(LPCTSTR)strIniFile );
	} else {
		WritePrivateProfileString( "Preference","AutoRenameAtMove" ,"FALSE" ,(LPCTSTR)strIniFile );
	}
	if( m_bDeleteImmediate==TRUE ){
		WritePrivateProfileString( "Preference","DeleteImmediate" ,"TRUE" ,(LPCTSTR)strIniFile );
	} else {
		WritePrivateProfileString( "Preference","DeleteImmediate" ,"FALSE" ,(LPCTSTR)strIniFile );
	}

	WritePrivateProfileString( "Directory","OpenWindowProgram" ,(LPCTSTR)m_strOpenWindowProgram ,(LPCTSTR)strIniFile );
	WritePrivateProfileString( "Directory","URLProgram"        ,(LPCTSTR)m_strURLProgram        ,(LPCTSTR)strIniFile );
	WritePrivateProfileString( "Directory","URLMemo"           ,(LPCTSTR)m_strURLMemo           ,(LPCTSTR)strIniFile );

	// TCY폜
	sprintf( cBuffer , "%d" , m_iDeleteSmallWidth );
	WritePrivateProfileString( "DeleteSmall" , "Width" , cBuffer , (LPCTSTR)strIniFile );

	sprintf( cBuffer , "%d" , m_iDeleteSmallHeight );
	WritePrivateProfileString( "DeleteSmall" , "Height" , cBuffer , (LPCTSTR)strIniFile );

	m_straFileType.Release();				// t@C^Cv̉
	m_aSpiUnit.Release();					// SPIz
}


//-----------------------------------------------< t@CXg̎荞 >
void CEmiDlg::LoadFileList( CString& strBasePath )
{
	BOOL bResFileFind;

	CString strTitle = "- EMI -";
	strTitle += " [";
	strTitle += strBasePath;
	strTitle += "]";
	this->SetWindowText( strTitle );

	// Xg{bNX
	m_lbFileList.ResetContent();
	for( int i=0;i<m_aSpiUnit.GetRegistedNum();i++ ){
		m_aSpiUnit[i].FreePicture();
	}

	// t@Cp쐬
	CString strFindString;							// t@Cp
													// nꂽx[XpXɁu\v⊮
	strFindString = AddBSToDirName( (LPCTSTR)strBasePath );
	strFindString += CString( "*.*" );				// ŌɁu*.*vǉ

	// Jn
	CFileFind ffFileFind;							// CFindFile IuWFNg̍쐬
	bResFileFind = ffFileFind.FindFile( strFindString,0 );			// x[XpX̑St@CΏۂƂ

	int	iDirNum = 0;
	BOOL bRes;
	bRes = TRUE;
	while( (bRes==TRUE) && (bResFileFind==TRUE) ){	// I܂ŌJԂ
		bRes = ffFileFind.FindNextFile();		// t@Co

		// t@Co
		CString strName;
		strName = ffFileFind.GetFileName();
		strName.MakeUpper();

		// fBNgȂgbvɒǉB
		BOOL bIsDirectoryEntry = FALSE;
		if( ffFileFind.IsDirectory() ){
			CString strName;
			strName = ffFileFind.GetFileName();						// t@C擾
			if( strcmp( (LPCTSTR)strName,"." )==0 )continue;		// ̃fBNg͓o^ȂB
			if( strcmp( (LPCTSTR)strName,".." )==0 )continue;		// ẽfBNg͓o^ȂB

			//
			strName = CString( "\n " ) + strName + CString( " ]" );	// fBNg쐬
																	// \n ̓t@CɎgȂł
																	// At@CɎgSĂ̕
																	// R[hB]āA̕
																	// Kt@CɈʒu邱ƂɂȂB

			int iIndex;
			iIndex = m_lbFileList.AddString( strName );
			m_lbFileList.SetItemDataPtr( iIndex,(void*)-1 );		// fBNg -1 B
			iDirNum += 1;											// fBNg{P

			// fBNgύX
			{
				// ACe|C^Ƃ
				void* pVoid = m_lbFileList.GetItemDataPtr( iIndex );

				// fBNgĕϊ
				CString strDirName;
				m_lbFileList.GetText( iIndex , strDirName );
				strDirName.Replace( '\n' , '[' );

				// lĐݒ肷B
				m_lbFileList.DeleteString( iIndex );
				m_lbFileList.InsertString( iIndex , strDirName );
				m_lbFileList.SetItemDataPtr( iIndex , pVoid );
			}
			continue;
		}

		// gqo
		const char* pExt = (LPCTSTR)strName;
		while( 1 ){
			char* pWork;
			pWork = strchr( pExt,'.' );
			if( pWork==NULL )break;
			pExt = pWork+1;
		}
		if( pExt==(LPCTSTR)strName )continue;		// gqt@CȂ玟

		// gqgp\ǂ𒲂ׁAgp\Ȃ烊Xgɓo^
		BOOL bUsable;
		bUsable = FALSE;

		CSpiUnit* pSpiUnit;
		pSpiUnit = NULL;
		if( strcmp( pExt,"BMP" )==0 )bUsable = TRUE;		// BMPȂ疳ŎgB
		else {
			for( int i=0;i<m_aSpiUnit.GetRegistedNum();i++ ){
				if( m_aSpiUnit[i].IsType( (const char*)pExt )==TRUE ){
					pSpiUnit = &(m_aSpiUnit[i]);
					bUsable  = TRUE;
					break;
				}
			}
		}
		if( bUsable==FALSE )continue;							// gȂȂ玟ցB

		// Xg֓o^
		int iIndex;
		iIndex = m_lbFileList.AddString( (LPCTSTR)ffFileFind.GetFileName() );
		m_lbFileList.SetItemDataPtr( iIndex,pSpiUnit );

		// WindowsbZ[W
		DoDispatchWindowsMessage();
	}
/*
	// fBNg̕CB@擪́u\nvu[vɂB
	for( i=0;i<iDirNum;i++ ){
		// ACe|C^Ƃ
		void* pVoid = m_lbFileList.GetItemDataPtr( i );

		// fBNgĕϊ
		CString strDirName;
		m_lbFileList.GetText( i , strDirName );
		strDirName.Replace( '\n' , '[' );

		// lĐݒ肷B
		m_lbFileList.DeleteString( i );
		m_lbFileList.InsertString( i , strDirName );
		m_lbFileList.SetItemDataPtr( i , pVoid );
	}
*/
	// ̍XV
	m_lbFileList.SetCurSel( 0 );								// I
	m_iViewingIndex = 0;
	UpdateData( FALSE );
}


//-----------------------------------------------< fBNgύX >
CString CEmiDlg::ChangeDirectory()
{
	// fBNgI
	CString strMessage = "fBNgI\ñfBNg̉摜t@Cɂđ삵܂B";
	CString strOldBasePath = m_strBasePath;

	CString strRes = this->SelectFolder( m_strBasePath , strMessage );
	if( strRes.GetLength()==0 ){
		return m_strBasePath;
	}
	m_strBasePath = strRes;

	// Xg{bNXXV
	LoadFileList( m_strBasePath );
	OnSelchangeFilelist();
	CDC* pDC;
	pDC = GetDC();
	DrawScreen( pDC );
	ReleaseDC( pDC );

	return strRes;
}


//-----------------------------------------------< fBNgύX{^ꂽ >
void CEmiDlg::OnChangedir() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// fBNgI
	ChangeDirectory();
}

//-----------------------------------------------< gp\SPI}bv >
void CEmiDlg::MapSPI()
{
	int i;

	// ܂
	for( i=0;i<m_aSpiUnit.GetRegistedNum();i++ ){
		m_aSpiUnit[i].Free();						// SPI
	}
	m_aSpiUnit.Release();							// SPIz

	// ǂݍ
	CString strSearch;
	strSearch = CString( "SPI\\*.SPI" );

	BOOL bRes;
	CFileFind cFileFind;
	bRes = cFileFind.FindFile( strSearch,0 );
	if( bRes==FALSE )return;

	bRes = TRUE;
	while( bRes ){
		bRes = cFileFind.FindNextFile();
		CString strPath;
		strPath = cFileFind.GetFilePath();
		if( strcmp( GetExtension( (LPCTSTR)strPath ) , "SPI" )!=0 )continue;

		CSpiUnit spiSpiUnit;
		BOOL bUsable;
		bUsable = spiSpiUnit.Load( (char*)((LPCTSTR)strPath) );
		if( bUsable==FALSE )continue;				// SPIΉĂȂꍇ͎sBցB

		m_aSpiUnit.Add( spiSpiUnit );				// vfǉ

		int iIndex;
		iIndex = m_aSpiUnit.GetRegistedNum()-1;
		for( int i=0;i<m_aSpiUnit[iIndex].GetTypeNum();i++ ){
			char* pExt;
			pExt = m_aSpiUnit[iIndex].GetTypeExtension( i );
			m_straFileType.Add( pExt );
		}
	}
}

//-----------------------------------------------< IύXꂽƂ >
//
void CEmiDlg::OnSelchangeFilelist() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// ݓǂ܂Ă摜̉
	CSpiUnit* pSpiUnit;
	pSpiUnit = (CSpiUnit*)m_lbFileList.GetItemDataPtr( m_iViewingIndex );
	if( (int)pSpiUnit!=-1 ){					// G[ȂA݂͓ǂݍ܂ĂȂ
		if( pSpiUnit==NULL )m_Bmp.Free();			// BMPȂBMP
		else pSpiUnit->FreePicture();				// SPIȂ摜
	}

	// `ItZbg̏
	m_lOffsetX = 0;
	m_lOffsetY = 0;

	// Vɓǂރt@C̃t@C쐬
	m_iViewingIndex = m_lbFileList.GetCurSel();			// IĂCfbNXXV
	pSpiUnit = (CSpiUnit*)m_lbFileList.GetItemDataPtr( m_iViewingIndex );
	if( pSpiUnit==(void*)(-1) ){			// IꂽCfbNX摜ȂΕԂ
		CDC* pDC = GetDC();
		DrawScreen( pDC );
		ReleaseDC( pDC );

		DrawDirTopPicture();
		return;
	}

	CString strPathName,strFileName;					// ǂݍ݃t@C̃pXƃt@C
	strPathName = AddBSToDirName( (LPCTSTR)m_strBasePath );
	m_lbFileList.GetText( m_iViewingIndex,strFileName );

	// ǂݍ
	CDC* pDC;
	pDC = GetDC();
	if( pSpiUnit==NULL ){
		m_Bmp.Load( (LPCTSTR)(strPathName+strFileName),pDC );
	} else {
		pSpiUnit->LoadPicture( (LPCTSTR)(strPathName+strFileName) );
	}
	DrawScreen( pDC );

	ReleaseDC( pDC );
}


void CEmiDlg::DrawDirTopPicture() 
{
	if( m_iViewingIndex==-1 )return;

	//-----
	CSpiUnit* pSpiUnit = (CSpiUnit*)NULL;
		CString strName;
		strName = GetDirName();

		CFileFind ffFirstFind;
		CString strSearchPath = AddBSToDirName( (LPCTSTR)m_strBasePath ) + strName;
		CString strDirPath = AddBSToDirName( (LPCTSTR)strSearchPath );
		strSearchPath = strDirPath + "*.*";

		BOOL bFileFindResult;
		bFileFindResult = ffFirstFind.FindFile( strSearchPath,0 );
		if( bFileFindResult==FALSE ){ return; }

		BOOL bFileExists = TRUE;
		BOOL bUsable = FALSE;
		CString strFirstPath;
		while( bFileExists ){
			bFileExists = ffFirstFind.FindNextFile();
			if( ffFirstFind.IsDirectory() ) { continue; }

			strFirstPath = ffFirstFind.GetFilePath();

			// gqo
			const char* pExt = (LPCTSTR)strFirstPath;
			while( 1 ){
				char* pWork;
				pWork = strchr( pExt,'.' );
				if( pWork==NULL )break;
				pExt = pWork+1;
			}
			if( pExt==(LPCTSTR)strFirstPath )continue;		// gqt@CȂ玟

			// gqgp\ǂ𒲂ׁAgp\Ȃ烊Xgɓo^
			bUsable = FALSE;

			if( stricmp( pExt,"BMP" )==0 )bUsable = TRUE;		// BMPȂ疳ŎgB
			else {
				for( int i=0;i<m_aSpiUnit.GetRegistedNum();i++ ){
					if( m_aSpiUnit[i].IsType( (const char*)pExt )==TRUE ){
						pSpiUnit = &(m_aSpiUnit[i]);
						bUsable  = TRUE;
						break;
					}
				}
			}
			if( bUsable==TRUE )break;							// gȂȂ玟ցB
		}
		if( bUsable==FALSE ){
			return;
		} else {
			// ǂݍ
			CDC* pDC;
			pDC = GetDC();
			if( pSpiUnit==NULL ){
				m_Bmp.Load( (LPCTSTR)(strFirstPath),pDC );
			} else {
				pSpiUnit->LoadPicture( (LPCTSTR)(strFirstPath) );
			}
			DrawScreen( pDC , TRUE , pSpiUnit );

			ReleaseDC( pDC );
			return;
		}
}

//-----------------------------------------------< ʂ̕\ItZbgύX >
BOOL CEmiDlg::PictureOffset( int dx , int dy )
{
	long lOldX , lOldY;
	lOldX	= m_lOffsetX;
	lOldY	= m_lOffsetY;

	// ItZbgʒuύX
	m_lOffsetX += dx;
	m_lOffsetY += dy;

	// ĕ`
	CDC* pDC;
	pDC = GetDC();
	DrawScreen( pDC,FALSE );
	ReleaseDC( pDC );

	// łɓBς݂
	BOOL bAlready = FALSE;
	if( (lOldX==m_lOffsetX) && (lOldY==m_lOffsetY) ){
		bAlready = TRUE;
	}

	// ʂԂ
	return bAlready;
}


//-----------------------------------------------< ʂ̕` >
void CEmiDlg::DrawScreen(CDC *pDC,BOOL bReDrawBack,CSpiUnit* pSpiUnit)
{
	// `GǍvZ
	RECT rectWindow;									// EBhE̋`
	RECT rectListBox;									// Xg{bNX̋`
	RECT rectDraw;										// `GA̋`
	GetWindowRect( &rectWindow );
	m_lbFileList.GetWindowRect( &rectListBox );
	GetClientRect( &rectDraw );
	rectDraw.left += (rectListBox.right - rectWindow.left);


	// ʂ
	COLORREF colBk;
	colBk = 0;
	if( bReDrawBack )pDC->FillSolidRect( &rectDraw,colBk );


	// gp SPI 擾
	//CSpiUnit* pSpiUnit;
	if( pSpiUnit==NULL ){
		pSpiUnit = (CSpiUnit*)m_lbFileList.GetItemDataPtr( m_iViewingIndex );
		if( (int)pSpiUnit==-1 )return;			// G[ԂĂÂ܂ܕԂ
	}


	// \摜̑傫擾
	RECT rectPicture;
	if( pSpiUnit==NULL ){					// BMP ̏ꍇ
		rectPicture.left = 0;
		rectPicture.top = 0;
		rectPicture.right = rectPicture.left + m_Bmp.GetWidth();
		rectPicture.bottom = rectPicture.top + m_Bmp.GetHeight();
	} else {
		rectPicture.left = 0;
		rectPicture.top = 0;
		rectPicture.right = rectPicture.left + pSpiUnit->GetWidth();
		rectPicture.bottom = rectPicture.top + pSpiUnit->GetHeight();
	}


	// `ItZbgݒ
	// ̃ItZbg͖B
	if( m_lOffsetX<0 )m_lOffsetX=0;
	if( m_lOffsetY<0 )m_lOffsetY=0;

	if( m_bStretch==TRUE ){			// Xgb`ꍇ̓ItZbgȂ
		m_lOffsetX = 0;
		m_lOffsetY = 0;
	} else {						// Xgb`Ȃꍇ̓ItZbg
		// 摜`̈̕LȂItZbg͕KvȂB
		if( (rectPicture.right-(rectPicture.left+m_lOffsetX))<=(rectDraw.right-rectDraw.left) ){
			m_lOffsetX = (rectPicture.right-rectPicture.left)-(rectDraw.right-rectDraw.left);
			if( m_lOffsetX<0 )m_lOffsetX = 0;
		}
		if( (rectPicture.bottom-(rectPicture.top+m_lOffsetY))<=(rectDraw.bottom-rectDraw.top) ){
			m_lOffsetY = (rectPicture.bottom-rectPicture.top)-(rectDraw.bottom-rectDraw.top);
			if( m_lOffsetY<0 )m_lOffsetY = 0;
		}
	}

	if( pSpiUnit==NULL ){
		rectPicture.left   += m_lOffsetX;
		rectPicture.top    += m_lOffsetY;
	} else {
		rectPicture.left   += m_lOffsetX;
		rectPicture.bottom -= m_lOffsetY;
	}


	// \摜̑傫AWXg
	RECT rectTarget;
	if( m_bStretch ){									// Xgb`ꍇ
		rectTarget = AdjustRect( &rectPicture,&rectDraw );
	} else {											// Xgb`Ȃꍇ
		// ^[Qbg̈AG̑傫ō
		rectTarget.top		= rectDraw.top;
		rectTarget.left		= rectDraw.left;
		rectTarget.right	= rectTarget.left + (rectPicture.right-rectPicture.left);
		rectTarget.bottom	= rectTarget.top  + (rectPicture.bottom-rectPicture.top);

		// `̈悩I[o[镔Jbg
		if( (rectDraw.right-rectDraw.left)<(rectPicture.right-rectPicture.left) ){
			long lOverX;
			lOverX = (rectPicture.right-rectPicture.left) - ( rectDraw.right-rectDraw.left );
			rectTarget.right -= lOverX;
			rectPicture.right -= lOverX;
		}
		if( (rectDraw.bottom-rectDraw.top)<(rectPicture.bottom-rectPicture.top) ){
			long lOverY;
			lOverY = (rectPicture.bottom-rectPicture.top) - ( rectDraw.bottom-rectDraw.top );
			// SPI ̂Ƃ́ATOP 𒲐BBMP ̂Ƃ BOTTOM 𒲐BWnႤ̂ɂH
			rectTarget.bottom -= lOverY;
			if( pSpiUnit!=NULL )rectPicture.top += lOverY;
			else rectPicture.bottom -= lOverY;
		}

		// ]󂭂ȂA^񒆂Ɋ񂹂B
		if( rectPicture.right<(rectDraw.right-rectDraw.left) ){
			rectTarget.left += ( (rectDraw.right-rectDraw.left)-rectPicture.right )/2;
			rectTarget.right += ( (rectDraw.right-rectDraw.left)-rectPicture.right )/2;
		}
		if( rectPicture.bottom<(rectDraw.bottom-rectDraw.top) ){
			rectTarget.top += ( (rectDraw.bottom-rectDraw.top)-rectPicture.bottom )/2;
			rectTarget.bottom += ( (rectDraw.bottom-rectDraw.top)-rectPicture.bottom )/2;
		}
	}


	// `悷
	if( (int)pSpiUnit!=-1 ){				// G[AĂ牽ȂB
		if( pSpiUnit==NULL ){				// `
			m_Bmp.StretchDraw( CRect( rectPicture ),CRect( rectTarget ),pDC );
		} else {
			pSpiUnit->StretchDraw( pDC->GetSafeHdc(),&rectPicture,&rectTarget );
		}
	}
}

//-----------------------------------------------< `AWXg >
//
RECT CEmiDlg::AdjustRect(LPRECT pSrcRect, LPRECT pDstRect)
{
	RECT resRect;
	memset( &resRect,0,sizeof( resRect ) );

	LONG lSrcWidth,lSrcHeight,lDstWidth,lDstHeight;			// ^ꂽ`̕ӂ̒
	lSrcWidth = pSrcRect->right - pSrcRect->left;
	lDstWidth = pDstRect->right - pDstRect->left;
	lSrcHeight = pSrcRect->bottom - pSrcRect->top;
	lDstHeight = pDstRect->bottom - pDstRect->top;

	if( (lSrcWidth<=0)||(lSrcHeight<=0) )return *pDstRect;	// ӂ̒sȂϊȂŕԂ


	LONG lCnvWidth,lCnvHeight;								// ϊ̕ӂ̒
	// ̔{ŉ摜ϊB
	lCnvWidth  = lDstWidth;								// lSrcWidth  * ( lDstWidth/lSrcWidth );
	lCnvHeight = (lSrcHeight*lDstWidth)/lSrcWidth;		// lSrcHeight * ( lDstWidth/lSrcWidth );

	if( lCnvHeight>lDstHeight ){							// 傫I[o[ȂAcōĒ
		lCnvHeight  = lDstHeight;							// lSrcHeight * ( lDstHeight/lSrcHeight );
		lCnvWidth   = (lSrcWidth*lDstHeight)/lSrcHeight;	// lSrcWidth  * ( lDstHeight/lSrcHeight );
	}

	resRect.left = pDstRect->left;
	resRect.top  = pDstRect->top;
	resRect.right = pDstRect->left + lCnvWidth;
	resRect.bottom = pDstRect->top + lCnvHeight;

	long lOffX,lOffY;
	lOffX = ( pDstRect->right  - resRect.right  )/2;
	lOffY = ( pDstRect->bottom - resRect.bottom )/2;
	resRect.left += lOffX;
	resRect.right += lOffX;
	resRect.top += lOffY;
	resRect.bottom += lOffY;

	return resRect;
}


//-----------------------------------------------< EBhẼTCYύXꂽ >
void CEmiDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if( m_bLayoutReady )LayoutObjects();		// IuWFNgĔzu
	Invalidate();								// S̈`
}


//-----------------------------------------------< bZ[WOɏ >
BOOL CEmiDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

	switch( pMsg->message ){
	case WM_KEYDOWN:
		switch( pMsg->wParam ){

		case VK_F5:							// [h
			ReloadFileList();
			return TRUE;
			break;

		case VK_SPACE:							// Xy[XŃXgb`[hؑ
			if( m_bStretch==TRUE )m_bStretch = FALSE;
			else m_bStretch = TRUE;
			CDC* pDC;
			pDC = GetDC();
			DrawScreen( pDC );
			{
				// fBNgۂ𒲂ׂ
				BOOL bIsDir = IsDir();
				if( bIsDir==TRUE ){
					DrawDirTopPicture();
				}
			}
			ReleaseDC( pDC );
			return TRUE;
			break;

		case VK_UP:
		case VK_DOWN:
			//if( GetAsyncKeyState( VK_CONTROL )&0x8000 ){
			if( IsDir()==FALSE ){
				BOOL bAlready = FALSE;

				// EBhETCY擾
				RECT rectClient;
				GetClientRect( &rectClient );

				// ItZbg
				if( pMsg->wParam==VK_UP ){
					bAlready = PictureOffset( 0 , -rectClient.bottom );
				} else {
					bAlready = PictureOffset( 0 , rectClient.bottom );
				}
				if( bAlready==FALSE ){
					// Bς݂łȂꍇ́A摜؂ւȂ
					return TRUE;
				}
			}
			break;

		case VK_ESCAPE:							// ESCł̏I֎~
			return TRUE;
			break;

		case VK_LEFT:
			WalkOutDirectory();
			return TRUE;
			break;

		case VK_RIGHT:
			WalkInDirectory();
			return TRUE;
			break;


		case VK_INSERT:								// t@C̈ړ
		case 'M':								// t@C̈ړ
			if( (GetAsyncKeyState( VK_CONTROL )&0x8000)==0 ){
				// CTRLȂ̏ꍇ́Aړ
				BOOL bMoveRes;
				bMoveRes = MovePictureFile();
				if( bMoveRes==FALSE ){
					CString strError;
					strError  = CString( "ړs\nړDir  : " ) + m_strMoveDir;
					MessageBox( (LPCTSTR)strError,"Error",MB_OK );
				}
			} else {
				// CTRL ̂Ƃɂ́AړύX
				this->ChangeMoveDir();
			}
			return TRUE;
			break;

		case 'R':
			RenameFile();
			return TRUE;
			break;

		case 'T':								// t@C̔j
			{
			BOOL bDeleteRes;
			BOOL bShift		= (GetAsyncKeyState( VK_SHIFT )&0x8000)!=0;
			BOOL bControl	= (GetAsyncKeyState( VK_CONTROL )&0x8000)!=0;
			if( (bShift==TRUE) && (bControl==TRUE) ){
				// mF
				if( IsDir()==TRUE ){
					MessageBox( "fBNgI͎sł܂B" );
					return TRUE;
				}

				// Vtg{CTRLȂ̂Ƃ́ATCYȉ̂̂폜
				bDeleteRes = DeleteSmallPicture();

				// J[\
				if( bDeleteRes==FALSE ){
					CursorToLower();
				}
				return TRUE;
			}
			if( (bControl==TRUE) && (bShift==FALSE) ){
				this->ChangeTrashDir();
				return TRUE;
			}
			return TRUE;
			}
			break;

		case VK_DELETE:
			BOOL bTrashRes;
			//if( GetAsyncKeyState( VK_SHIFT )&0x8000 ){
			if( IsDir()==TRUE ){
				// VtgȂ̂Ƃ̓fBNg܂ō폜
				bTrashRes = DeleteDir();
			} else {
				// VtgȂƂ͂ݔړ
				bTrashRes = TrashPictureFile();
				if( bTrashRes==FALSE ){
					CString strError;
					strError  = CString( "ړs\nړDir  : " ) + m_strTrashDir;
					MessageBox( (LPCTSTR)strError,"Error",MB_OK );
				}
			}
			return TRUE;
			break;

		case 'C':								// t@C̃Rs[
			if( (GetAsyncKeyState( VK_CONTROL )&0x8000)==0 ){
				BOOL bCopyRes;
				bCopyRes = CopyPictureFile();
				if( bCopyRes==FALSE ){
					CString strError;
					strError  = CString( "Rs[s\nRs[Dir  : " ) + m_strCopyDir;
					MessageBox( (LPCTSTR)strError,"Error",MB_OK );
				}
			} else {
				this->ChangeCopyDir();
			}
			return TRUE;
			break;

		case 'K':								// t@C폜
			{
			BOOL bDeleteRes;
			BOOL bShift		= (GetAsyncKeyState( VK_SHIFT )&0x8000)!=0;
			BOOL bControl	= (GetAsyncKeyState( VK_CONTROL )&0x8000)!=0;
			if( (bShift==TRUE) && (bControl==FALSE) ){
				// VtgȂ̂Ƃ̓fBNg܂ō폜
				bDeleteRes = DeleteDir();
				return TRUE;
			}
			{
				// VtgȂ̏ꍇ̓t@Ĉ
				bDeleteRes = DeletePictureFile();
				if( bDeleteRes==FALSE ){
					CString strError;
					strError  = CString( "폜s\n" );
					MessageBox( (LPCTSTR)strError,"Error",MB_OK );
				}
			}
			}
			return TRUE;
			break;

		case 'D':								// fBNgύX
			ChangeDirectory();
			return TRUE;
			break;

		case 'P':								// ݒ_CAO
			OnPreference();
			return TRUE;
			break;

		case 'J':								// Wv_CAO
			OnJump();
			return TRUE;
			break;

		case 'W':								// ǎƂĂaloZ[u
			if( (GetAsyncKeyState(VK_CONTROL)&0x8000) == 0 ){
				BOOL bSaveBMPRes;
				bSaveBMPRes	= SaveWallPaper( FALSE );
				if( bSaveBMPRes==FALSE ){
					CString strError;
					strError  = CString( "ǎpalo쐬s\n" );
					MessageBox( (LPCTSTR)strError,"Error",MB_OK );
				}
			} else {
				OpenExplore();
			}
			return TRUE;
			break;

		case 'I':
			{
				OpenIExplore();
			}
			return TRUE;
			break;

		case VK_RETURN:							// ǎύX
			{
				// WindowsfBNg̎擾
				char cWinDir[_MAX_PATH];
				GetWindowsDirectory( cWinDir , _MAX_PATH );
				CString strWinDir;
				strWinDir = AddBSToDirName( cWinDir );

				// 쐬alõtpX쐬
				CString strBMP;
				strBMP	= strWinDir + CString( "WallPaperCreatedByEMI.bmp" );

				BOOL bSaveBMPRes;
				bSaveBMPRes	= SaveWallPaper( TRUE , (LPCTSTR)strBMP );
				if( bSaveBMPRes==FALSE ){
					CString strError;
					strError  = CString( "ǎύXs\n" );
					MessageBox( (LPCTSTR)strError,"Error",MB_OK );
				}
			}
			return TRUE;
			break;

		case VK_F12:							// ǎƂĂaloZ[uAǎύX
			{
				BOOL bSaveBMPRes;
				bSaveBMPRes	= SaveWallPaper( TRUE );
				if( bSaveBMPRes==FALSE ){
					CString strError;
					strError  = CString( "ǎpalo쐬^ύXs\n" );
					MessageBox( (LPCTSTR)strError,"Error",MB_OK );
				}
			}
			return TRUE;
			break;
		}

		break;
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}


//-----------------------------------------------< }EX >
void CEmiDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	static CPoint pntOldPoint = CPoint( 0,0 );

	// NbNĂƂ̂ݏ
	if( nFlags&MK_LBUTTON ){
		// ItZbgʒuύX
		int dx = point.x-pntOldPoint.x;
		int dy = point.y-pntOldPoint.y;
		PictureOffset( -dx , -dy ); 

		// ĕ`
		CDC* pDC;
		pDC = GetDC();
		DrawScreen( pDC,FALSE );
		ReleaseDC( pDC );
	}

	// ߋʒu̍XV
	pntOldPoint = point;
	CDialog::OnMouseMove(nFlags, point);
}


//-----------------------------------------------< IuWFNg̍Ĕzu >
void CEmiDlg::LayoutObjects()
{
	// NCAg̈擾
	RECT rectClient;
	GetClientRect( &rectClient );

	// {^̗̈擾
	RECT rectBtn;
	m_btnChangeDir.GetWindowRect( &rectBtn );

	// Xg{bNẌ̗擾
	RECT rectLB;
	m_lbFileList.GetWindowRect( &rectLB );

	// `ʒu̐ݒifBNgύX{^j
	m_btnChangeDir.SetWindowPos(
		 &wndTopMost
		,rectClient.left
		,rectClient.bottom-(rectBtn.bottom-rectBtn.top)
		,0
		,0
		,SWP_NOSIZE | SWP_NOZORDER | SWP_SHOWWINDOW );

	// `ʒu̐ݒiXg{bNXj
	m_lbFileList.SetWindowPos(
		 &wndTopMost
		 ,rectClient.left
		 ,rectClient.top
		 ,rectLB.right-rectLB.left
		 ,(rectClient.bottom-rectClient.top)-(rectBtn.bottom-rectBtn.top)
		 ,SWP_NOZORDER | SWP_SHOWWINDOW );
}


//-----------------------------------------------< {^ꂽ >
//
void CEmiDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetCapture();							// }EX̃Lv`
	
	CDialog::OnLButtonDown(nFlags, point);
}


//-----------------------------------------------< {^͂Ȃꂽ >
//
void CEmiDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	ReleaseCapture();
	
	CDialog::OnLButtonUp(nFlags, point);
}


//-----------------------------------------------< t@C̈ړ >
//
BOOL CEmiDlg::MovePictureFile()
{
	int i;

	if( (int)(m_lbFileList.GetItemDataPtr( m_iViewingIndex ))==-1 ){	// ȃGgȂ
		return TRUE;													// ̂܂ܕԂ
	}

	// ړAړ̃pX쐬
	CString	strFile;							// ƃt@C
	CString strPath;							// ƃpX
	CString	strDest;							// ړpX
	m_lbFileList.GetText( m_iViewingIndex , strFile );					// ړƃt@C
	strPath = AddBSToDirName( (LPCTSTR)m_strBasePath ) + strFile;		// 쐬
	strDest = AddBSToDirName( (LPCTSTR)m_strMoveDir  ) + strFile;		// ړfBNgݒ

	// t@CmF
	if( this->m_bAutoRenameAtMove==TRUE ){
		for( i=0;i<10000;i++ ){
			// mF
			FILE* pFn = fopen( strDest , "rb" );
			if( pFn==NULL ){
				break;
			}
			fclose( pFn );

			// ꍇÂςĂ݂
			CString strExt	= GetExtension( strDest );
			CString strFName = GetFileNameFromPath( strDest );
			strFName = strFName.Left( strFName.GetLength() - strExt.GetLength() -1 );
			if( i>=1 ){
				strFName = strFName.Left( strFName.GetLength()-5 );
			}

			CString nextName;
			nextName.Format( "%s_%04d.%s" , (LPCTSTR)strFName , i , (LPCTSTR)strExt );
			strDest = AddBSToDirName( (LPCTSTR)m_strMoveDir  ) + nextName;
		}
	}

	// t@C̈ړ
	BOOL bRes;
	bRes = ::MoveFile( (LPCTSTR)strPath,(LPCTSTR)strDest );

	// j[ACe폜
	if( bRes==TRUE )DeleteViewingItemFromFileList();

	return bRes;
}


//-----------------------------------------------< t@C̔j >
//
BOOL CEmiDlg::TrashPictureFile()
{

	if( (int)(m_lbFileList.GetItemDataPtr( m_iViewingIndex ))==-1 ){	// ȃGgȂ
		return TRUE;													// ̂܂ܕԂ
	}

	// ړAړ̃pX쐬
	CString	strFile;							// ƃt@C
	CString strPath;							// ƃpX
	CString	strDest;							// ړpX
	m_lbFileList.GetText( m_iViewingIndex , strFile );					// ړƃt@C
	strPath = AddBSToDirName( (LPCTSTR)m_strBasePath ) + strFile;		// 쐬
	strDest = AddBSToDirName( (LPCTSTR)m_strTrashDir  ) + strFile;		// ړfBNgݒ

	// t@C̈ړ
	BOOL bRes;
	bRes = ::MoveFile( (LPCTSTR)strPath,(LPCTSTR)strDest );

	// j[ACe폜
	if( bRes==TRUE )DeleteViewingItemFromFileList();

	return bRes;
}


//-----------------------------------------------< t@C̃Rs[ >
//
BOOL CEmiDlg::CopyPictureFile()
{

	if( (int)(m_lbFileList.GetItemDataPtr( m_iViewingIndex ))==-1 ){	// ȃGgȂ
		return TRUE;													// ̂܂ܕԂ
	}

	// Rs[ARs[̃pX쐬
	CString	strFile;							// ƃt@C
	CString strPath;							// ƃpX
	CString	strDest;							// Rs[pX
	m_lbFileList.GetText( m_iViewingIndex , strFile );					// ړƃt@C
	strPath = AddBSToDirName( (LPCTSTR)m_strBasePath ) + strFile;		// 쐬
	strDest = AddBSToDirName( (LPCTSTR)m_strCopyDir  ) + strFile;		// Rs[fBNgݒ

	// t@C̃Rs[
	BOOL bRes;
	bRes = ::CopyFile( (LPCTSTR)strPath,(LPCTSTR)strDest,TRUE );

	return bRes;
}


//-----------------------------------------------< t@C >
BOOL CEmiDlg::DeletePictureFile()
{
	if( m_bDeleteImmediate==FALSE ){
		MessageBox( "폜̋֎~Ă܂B\nKillR}h̓LZ܂B","Kill",MB_OK );
		return TRUE;
	}

	if( (int)(m_lbFileList.GetItemDataPtr( m_iViewingIndex ))==-1 ){	// ȃGgȂ
		return TRUE;													// ̂܂ܕԂ
	}

	// ړAړ̃pX쐬
	CString	strFile;							// ƃt@C
	CString strPath;							// ƃpX
	m_lbFileList.GetText( m_iViewingIndex , strFile );					// ړƃt@C
	strPath = AddBSToDirName( (LPCTSTR)m_strBasePath ) + strFile;		// 쐬

	// t@C
	BOOL bRes;
	bRes = ::DeleteFile( (LPCTSTR)strPath );

	// j[ACe폜
	if( bRes==TRUE )DeleteViewingItemFromFileList();

	return bRes;

}

//-----------------------------------------------< ȉ摜̂ݍ폜 >
BOOL CEmiDlg::DeleteSmallPicture()
{
	if( IsDir()==TRUE ){ return FALSE; }
	if( IsPictureReady()==FALSE ){ return FALSE; }

	// IĂSPIUnit𓾂
	CSpiUnit* pSpiUnit	= GetSelectedSPIUnit();
	if( (int)pSpiUnit==-1 ){
		// G[
		return FALSE;
	}

	// 摜̑傫𔻒肷
	int iWidth	= -1;
	int iHeight	= -1;
	if( pSpiUnit==NULL ){					// BMP ̏ꍇ
		iWidth	= m_Bmp.GetWidth();
		iHeight	= m_Bmp.GetHeight();
	} else {
		iWidth	= pSpiUnit->GetWidth();
		iHeight	= pSpiUnit->GetHeight();
	}

	// ȉȂ
	if( (iWidth<m_iDeleteSmallWidth) || (iHeight<m_iDeleteSmallHeight) ){
		DeletePictureFile();
		return TRUE;
	}
	return FALSE;
}

//-----------------------------------------------< fBNg܂߂ď >
BOOL CEmiDlg::DeleteDir()
{
	BOOL bRes;
	// -----< mF >-----
	//
	if( IsDir()==FALSE ){
		MessageBox( "fBNgł͂܂B\n" );
		return TRUE;
	}

	// -----< pX쐬 >-----
	//
	CString strPath;							// tpX
	CString strDirName = GetDirName();
	strPath = AddBSToDirName( (LPCTSTR)m_strBasePath ) + strDirName;	// 쐬

	// -----< 폜 >-----
	//
	bRes = DoDeleteDirectory( strPath );
	if( bRes==FALSE ){
		return FALSE;
	}

	// -----< t@CXgēǍ >-----
	//
	ReloadFileList();

	// -----< I >-----
	//
	return TRUE;
}


//-----------------------------------------------< t@CXgēǂݍ >
void CEmiDlg::ReloadFileList()
{
	int iRowIndex = this->m_lbFileList.GetCurSel();
	LoadFileList( m_strBasePath );

	// fBNgđI
	int iRowCount = m_lbFileList.GetCount();	// Xg̃ACe𐔂
	if( (iRowIndex>=0) && (iRowCount>0) ){
		if( iRowIndex>=iRowCount ){
			// NbsO
			iRowIndex = iRowCount-1;
		}
		m_lbFileList.SetCurSel( iRowIndex );
	}
	OnSelchangeFilelist();
}

//-----------------------------------------------< fBNgƍ폜 >
BOOL CEmiDlg::DoDeleteDirectory( CString strPath , BOOL bForce )
{
	CFileFind objFileFind;

	// SH...֐ł́At@C 0 ؂ŕpXw肳A0,0 ŊB
	long i;
	long lBufferSize = strPath.GetLength()+2;
	char* pName = (char*)malloc( lBufferSize );
	for( i=0;i<lBufferSize;i++ ){ pName[ i ] = 0; }
	strcpy( pName , (LPCTSTR)strPath );

	SHFILEOPSTRUCT sFileOp;
	memset( &sFileOp , 0 , sizeof( sFileOp ) );
	sFileOp.hwnd		= NULL;
	sFileOp.wFunc		= FO_DELETE; 
	sFileOp.pFrom		= pName;
	sFileOp.pTo			= "\0\0";
	sFileOp.fFlags		= FOF_ALLOWUNDO;
	if( bForce==TRUE ){
		sFileOp.fFlags |= FOF_NOCONFIRMATION;
	}
	sFileOp.fAnyOperationsAborted	= FALSE;
	sFileOp.hNameMappings			= NULL;
	sFileOp.lpszProgressTitle		= "폜";
	SHFileOperation( &sFileOp );

	free( pName );

	return TRUE;
}


//-----------------------------------------------< fBNgۂ𔻒 >
BOOL CEmiDlg::IsDir()
{
	BOOL bIsDir = FALSE;
	if( m_iViewingIndex==-1 ){
		// IȂ
		return FALSE;
	}

	// I𒆂̃ACe̕񂩂画肷
	CString strName;
	long lLastIndex = -1;
	m_lbFileList.GetText( m_iViewingIndex,strName );
	lLastIndex = strName.GetLength()-1;
	if( lLastIndex<1 ){
		// [] ݂Ȃ̂ŃfBNgł͂Ȃ
		return FALSE;
	}

	// E [] 邩
	LPCTSTR pName = (LPCTSTR)strName;
	if( pName!=NULL ){
		if( (pName[0]=='[') && (pName[lLastIndex]==']') ){
			// E [  ] Ȃ̂ŁAfBNg
			bIsDir = TRUE;
		}
	}
	return bIsDir;
}

//-----------------------------------------------< 摜IA\Ă邩ۂ𔻒肷 >
BOOL CEmiDlg::IsPictureReady()
{
	if( IsDir()==TRUE ){	// fBNgȂ
		return FALSE;		// 摜ł͂Ȃ
	}

	if( (int)(m_lbFileList.GetItemDataPtr( m_iViewingIndex ))==-1 ){	// ȃGgȂ
		return FALSE;													// 摜ł͂Ȃ
	}
	return TRUE;
}

//-----------------------------------------------< fBNg擾 >
CString CEmiDlg::GetDirName()
{
	CString strResult = "";
	if( IsDir()==FALSE ){ return strResult; }  // 񂪂Ȃ

	// I𒆂̃ACe擾
	CString strDirName = "";
	m_lbFileList.GetText( m_iViewingIndex,strDirName );

	// \ɂ邩mF
	long lLength = strDirName.GetLength();
	if( lLength<2 ){ return strResult; }

	// E [] 폜
	long lLastIndex = lLength - 1;
	if( strDirName.GetAt(0)=='[' ){
		strDirName.SetAt(0 , ' ');
	}
	if( strDirName.GetAt(lLastIndex)==']' ){
		strDirName.SetAt( lLastIndex , ' ' );
	}

	// E̋󔒂g
	strDirName.TrimLeft();
	strDirName.TrimRight();

	// ʂԂ
	strResult = strDirName;
	return strResult;
}

//-----------------------------------------------< I𒆂SPIUNIT𓾂 >
// -1:G[  0:BMP  ȊO:SPI
CSpiUnit* CEmiDlg::GetSelectedSPIUnit()
{
	// gp SPI 擾
	CSpiUnit* pSpiUnit;
	pSpiUnit = (CSpiUnit*)m_lbFileList.GetItemDataPtr( m_iViewingIndex );
	return pSpiUnit;
}

//-----------------------------------------------< ݌ĂACet@CXg폜 >
void CEmiDlg::DeleteViewingItemFromFileList()
{
	// j[ACe폜
	// ݓǂ܂Ă摜̉
	CSpiUnit* pSpiUnit;
	pSpiUnit = (CSpiUnit*)m_lbFileList.GetItemDataPtr( m_iViewingIndex );
	if( (int)pSpiUnit!=-1 ){					// G[ȂA݂͓ǂݍ܂ĂȂ
		if( pSpiUnit==NULL )m_Bmp.Free();			// BMPȂBMP
		else pSpiUnit->FreePicture();				// SPIȂ摜
	}

	// ACe폜
	m_lbFileList.DeleteString( m_iViewingIndex );

	int iNum;
	iNum = m_lbFileList.GetCount();
	if( m_iViewingIndex>=iNum )m_iViewingIndex = iNum-1;
	if( m_iViewingIndex<0 )m_iViewingIndex = 0;
	m_lbFileList.SetCurSel( m_iViewingIndex );
	OnSelchangeFilelist();
}


//-----------------------------------------------< ݒfBNgJ >
void CEmiDlg::OnPreference() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ

	// _CAÕIuWFNg쐬
	CPreference dlg;
	dlg.m_bDeleteImmediate		= m_bDeleteImmediate;
	dlg.m_strMoveDir			= m_strMoveDir;
	dlg.m_strTrashDir			= m_strTrashDir;
	dlg.m_strCopyDir			= m_strCopyDir;
	dlg.m_strWallPaperDir		= m_strWallPaperDir;
	dlg.m_bResizeToScreenSize	= m_bResizeWallPaperToScreenSize;
	dlg.m_bAutoRenameAtMove		= m_bAutoRenameAtMove;
	dlg.m_strOpenWindowProgram  = m_strOpenWindowProgram;
	dlg.m_strURLProgram			= m_strURLProgram;
	dlg.m_strURLMemo			= m_strURLMemo;

	// _CAOJ
	if( dlg.DoModal()==IDOK ){
		m_bDeleteImmediate	= dlg.m_bDeleteImmediate;
		m_strMoveDir		= dlg.m_strMoveDir;
		m_strTrashDir		= dlg.m_strTrashDir;
		m_strCopyDir		= dlg.m_strCopyDir;
		m_strWallPaperDir	= dlg.m_strWallPaperDir;
		m_strOpenWindowProgram	= dlg.m_strOpenWindowProgram;
		m_strURLProgram			= dlg.m_strURLProgram;
		m_strURLMemo			= dlg.m_strURLMemo;

		m_bResizeWallPaperToScreenSize	= dlg.m_bResizeToScreenSize;
		m_bAutoRenameAtMove				= dlg.m_bAutoRenameAtMove;
	}
}


//-----------------------------------------------< ްޮݏ >
void CEmiDlg::OnAboutbox() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CAboutDlg	dlg;
	dlg.DoModal();
}

void CEmiDlg::OnExit() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	DestroyWindow();
}

//-----------------------------------------------< \̉摜aloŕۑ >
BOOL CEmiDlg::SaveWallPaper( BOOL bChangeWallPaper , const char* pFName )
{
	// gp SPI 擾
	CSpiUnit* pSpiUnit;
	pSpiUnit = (CSpiUnit*)m_lbFileList.GetItemDataPtr( m_iViewingIndex );
	if( (int)pSpiUnit==-1 )return TRUE;		// G[ԂĂÂ܂ܕԂ

	// 쐬̃pX쐬
	CString	strDest;													// 쐬pX

	if( pFName==NULL ){
		// t@Cl[w肪Ȃ΁A\̃t@C̊gqςĕۑ
		CString	strFile;												// ƃt@C
		m_lbFileList.GetText( m_iViewingIndex , strFile );				// ړƃt@C
		strFile	= ReplaceExtension( (LPCTSTR)strFile , "BMP" );			// gqύX
		strDest = AddBSToDirName( (LPCTSTR)m_strWallPaperDir ) + strFile;	// 쐬pX
	} else {
		// t@Cl[w肪΁A̖Oŕۑ
		strDest = CString( pFName );
	}

	// aloƂrohŁAꂼ؂蕪
	BOOL bRes;
	if( pSpiUnit==NULL ){
		bRes = m_Bmp.SaveAsWallPaper( (LPCTSTR)strDest );
	} else {
		bRes = pSpiUnit->SaveAsWallPaper( (LPCTSTR)strDest );
	}
	if( bRes==FALSE )return FALSE;

	// ǎύX
	if( bChangeWallPaper ){
		bRes = SystemParametersInfo( SPI_SETDESKWALLPAPER , 0 , (void*)((LPCTSTR)strDest) , SPIF_UPDATEINIFILE );
	}

	// I
	return bRes;
}

//-----------------------------------------------< Wv_CAOJ >
void CEmiDlg::OnJump()
{
	// Wv_CAOJ
	CJumpDialog dlg;
	dlg.m_strCurrentPath	= m_strBasePath;
	dlg.m_strIniPath		= GetIniPath();
	if( dlg.DoModal()==IDCANCEL ){
		// LZꂽ瑦Ԃ
		return;
	}

	// fBNgύX
	if( dlg.m_strPathName.IsEmpty() )return;					// ʂȂ炻̂܂ܕԂB
	m_strBasePath = dlg.m_strPathName;							// pX擾
	LoadFileList( m_strBasePath );
	OnSelchangeFilelist();
}

//-----------------------------------------------< INIt@C̃pX擾 >
CString CEmiDlg::GetIniPath()
{
	CString strIniFile;
	char cBase[_MAX_PATH];
	GetModuleFileName( NULL,cBase,_MAX_PATH );
	strIniFile = GetBaseDir( cBase );
	strIniFile = AddBSToDirName( (LPCTSTR)strIniFile ) + CString( "Emi.ini" );

	return strIniFile;
}

//-----------------------------------------------< ExploreJ >
void CEmiDlg::OpenExplore()
{
	CString strCommandLine = m_strOpenWindowProgram + CString(" ");
	strCommandLine += this->m_strBasePath;
	WinExec( (LPCTSTR)strCommandLine , SW_SHOWDEFAULT );
}

//-----------------------------------------------< URLJ >
void CEmiDlg::OpenIExplore()
{
	// fBNgۂ𒲂ׂ
	BOOL bIsDir = FALSE;
	bIsDir = IsDir();

	CString strDirName = "";
	if( bIsDir==TRUE ){
		strDirName = GetDirName();
	}

	// <<< URLMemoJ >>>
	CString strFileName = this->m_strBasePath;
	if( strDirName != "" ){
		strFileName = AddBSToDirName( ((LPCTSTR)m_strBasePath) );
		strFileName += strDirName;
	}
	strFileName = AddBSToDirName( ((LPCTSTR)strFileName) ) + CString( "URLMemo.txt" );

	FILE* fn = fopen( (LPCTSTR)strFileName , "rt" );
	if( fn==NULL ){
		MessageBox( "URLMemo.txt J܂łB" );
		return;
	}

	// <<< e荞 >>>
	CString strURL = "";
	while( feof(fn)==0 ){
		char aryBuffer[ 4096 ];
		fgets( aryBuffer , 4095 , fn );
		if( feof( fn )!=0 ){ break; }

		CString strLine = aryBuffer;
		strLine.Replace( "\n" , "" );

		if( strLine.GetLength()!=0 ){
			strURL = strLine;
		}
	}

	// <<< 荞ݏI >>>
	fclose( fn );
	if( strURL.GetLength()==0 ){
		MessageBox( "URL܂B" );
		return;
	}

	// <<< s >>>
	CString strCommandLine = m_strURLProgram + CString(" ");
	strCommandLine += strURL;
	WinExec( (LPCTSTR)strCommandLine , SW_SHOWDEFAULT );
}

//-----------------------------------------------< ړݒ >
void CEmiDlg::ChangeMoveDir()
{
	CString strExp = "ړfBNgI\n'M'L[ƁAt@C̃fBNgɈړ܂B";
	CString	strRes	= SelectFolder( m_strMoveDir , strExp );
	if( strRes.GetLength()==0 ){
		// LZꂽ
		return;
	}
	m_strMoveDir = strRes;

	// fBNg쐬lāAt@CXg荞
	if( m_iViewingIndex>=0 ){
		CString strName = "";
		m_lbFileList.GetText( m_iViewingIndex,strName );
		LoadFileList( m_strBasePath );
		m_lbFileList.SelectString( 0 , strName );
		OnSelchangeFilelist();
	}
}

//-----------------------------------------------< Rs[ݒ >
void CEmiDlg::ChangeCopyDir()
{
	CString strExp = "Rs[fBNgI\n'C'L[ƁAt@C̃fBNgɈړ܂B";
	CString	strRes	= SelectFolder( m_strCopyDir , strExp );
	if( strRes.GetLength()==0 ){
		// LZꂽ
		return;
	}
	m_strCopyDir = strRes;

	// fBNg쐬lāAt@CXg荞
	if( m_iViewingIndex>=0 ){
		CString strName = "";
		m_lbFileList.GetText( m_iViewingIndex,strName );
		LoadFileList( m_strBasePath );
		m_lbFileList.SelectString( 0 , strName );
		OnSelchangeFilelist();
	}
}

//-----------------------------------------------< ݔݒ >
void CEmiDlg::ChangeTrashDir()
{
	CString strExp = "ݔfBNgI\n'DEL'L[ƁAt@C̃fBNgɈړ܂B";
	CString	strRes	= SelectFolder( m_strTrashDir , strExp );
	if( strRes.GetLength()==0 ){
		// LZꂽ
		return;
	}
	m_strTrashDir = strRes;

	// fBNg쐬lāAt@CXg荞
	if( m_iViewingIndex>=0 ){
		CString strName = "";
		m_lbFileList.GetText( m_iViewingIndex,strName );
		LoadFileList( m_strBasePath );
		m_lbFileList.SelectString( 0 , strName );
		OnSelchangeFilelist();
	}
}

//-----------------------------------------------< t@C l[ >
void CEmiDlg::RenameFile()
{
	if( m_lbFileList.GetCount()==0 )return;	// o^eȂ΃LZ
	if( m_lbFileList.GetCurSel()<0 )return; // IȂ΃LZ

	// <<< IĂ郂m̖̂𓾂 >>>
	CString strName = "";					// t@C
	BOOL	bIsDir	= IsDir();
	int		iLength;
	m_lbFileList.GetText( m_iViewingIndex,strName );
	iLength = strName.GetLength();
	if( bIsDir ){
		iLength -= 4;						// u[ vƁu ]v͂
		strName = strName.Mid( 2,iLength );	// fBNgo
	}

	// <<< tpX >>>
	CString strFullPath	= "";
	strFullPath	= m_strBasePath;
	strFullPath	= AddBSToDirName( (LPCTSTR)strFullPath );	// ̃x[XpX
	strFullPath += strName;						// tpX\z

	// <<< l[㖼 >>>
	int iRes;
	CRenameDialog objDialog;
	objDialog.m_strName = strName;
	iRes = objDialog.DoModal();
	if( iRes!=IDOK ){
		return;
	}
	CString strNewName	= objDialog.m_strName;

	// <<< l[s >>>
	CString strNewFullPath	= "";
	strNewFullPath	= m_strBasePath;
	strNewFullPath	= AddBSToDirName( (LPCTSTR)strNewFullPath );	// ̃x[XpX
	strNewFullPath += strNewName;									// tpX\z
	rename( (LPCTSTR)strFullPath , (LPCTSTR)strNewFullPath );

	// <<< IȂ >>>
	LoadFileList( m_strBasePath );
	CString strSelectString	= strNewName;
	if( bIsDir==TRUE ){
		strSelectString	= CString( "[ " ) + strNewName + CString( " ]" );
	}
	m_lbFileList.SelectString( 0 , strSelectString );
	OnSelchangeFilelist();
}

//-----------------------------------------------< tH_I >
CString CEmiDlg::SelectFolder( const CString& strCurrent , const CString& strExp )
{
	char	cDirName[_MAX_PATH];
	memset( cDirName,0,sizeof( cDirName ) );

	// BROWSEINFO 
	BROWSEINFO	sBI;
	sBI.hwndOwner		= GetSafeHwnd();
    sBI.pidlRoot		= NULL;
    sBI.pszDisplayName	= cDirName;
    sBI.lpszTitle		= (LPCTSTR)strExp;
    sBI.ulFlags			= BIF_NEWDIALOGSTYLE | BIF_RETURNONLYFSDIRS;
    sBI.lpfn			= CPreference::BrowseCallbackProc;
    sBI.lParam			= (long)( (LPCTSTR)strCurrent );
    sBI.iImage			= NULL;

	// fBNgI_CAO\
	LPITEMIDLIST lpRes;									// SHBrowseForFolder̖߂l
	CString		 strRes;								// ʂ̃fBNg
	lpRes = SHBrowseForFolder( &sBI );

	// ʂ̃fBNgݒ
	if( lpRes==NULL ){
		strRes = CString( "" );
	} else {
		SHGetPathFromIDList( lpRes,cDirName );
		strRes = CString( cDirName );
	}

	return strRes;
}

void CEmiDlg::OnSmallRange() 
{
	int iRes;
	CSizeSettingDialog objDialog;
	objDialog.m_iWidth	= this->m_iDeleteSmallWidth;
	objDialog.m_iHeight	= this->m_iDeleteSmallHeight;

	iRes = objDialog.DoModal();
	if( iRes!=IDOK ){
		return;
	}

	this->m_iDeleteSmallWidth	= objDialog.m_iWidth;
	this->m_iDeleteSmallHeight	= objDialog.m_iHeight;
}

//-----------------------------------------------< St@C TCY폜 >
void CEmiDlg::OnDeleteSmall() 
{
	int iRes;
	EnableControls( FALSE );

	// -----< sOmF >-----
	//
	// <<< t@C݊mF >>>
	if( m_lbFileList.GetCount()<=0 ){
		MessageBox( "Ώۃt@C܂B" );
		EnableControls( TRUE );
		return;
	}

	// <<< smF >>>
	iRes = MessageBox( "St@CɂāATCY폜s܂B\n낵łH" , "mF" , MB_OKCANCEL );
	if( iRes!=IDOK ){
		EnableControls( TRUE );
		return;
	}

	// <<< s >>>
	m_bOnDeleteSmall	= TRUE;
	DoDeleteSmall();
	m_bOnDeleteSmall	= FALSE;

	MessageBox( "I܂B" );
	EnableControls( TRUE );
	return;
}


int CEmiDlg::DoDeleteSmall()
{
	// -----< J[\擪 >-----
	//
	m_lbFileList.SetCurSel( 0 );
	OnSelchangeFilelist();
	int iCheckedCount = m_lbFileList.GetCount();

	// -----< JɎs >-----
	//
	while( 1 ){
		DoDispatchWindowsMessage();
		if( (GetAsyncKeyState( VK_ESCAPE )&0x8000) != 0 ){
			this->m_bOnDeleteSmall	= FALSE;
		}


		// LZ
		if( this->m_bOnDeleteSmall==FALSE ){
			break;
		}

		// W
		int iListCount		= m_lbFileList.GetCount();
		int iMaxIndex		= iListCount - 1;
		int iSelectedIndex	= m_lbFileList.GetCurSel();
		BOOL bIsDir			= IsDir();

		// G[mF
		if( iSelectedIndex<0 ){ break; }
		if( iMaxIndex<0      ){ break; }

		// 폜s
		BOOL bDeleteRes = FALSE;
		if( (bIsDir==FALSE) ){
			bDeleteRes = DeleteSmallPicture();
		}

		// J[\
		if( bDeleteRes==FALSE ){
			CursorToLower();
		}

		// I
		if( iSelectedIndex>=iMaxIndex ){ break; }
	}

	// -----< I >-----
	//
	if( m_lbFileList.GetCount()>0 ){
		m_lbFileList.SetCurSel( 0 );
		OnSelchangeFilelist();
	}

	return iCheckedCount;
}


//-----------------------------------------------< ċNISt@C TCY폜 >
void CEmiDlg::OnDeleteSmallRecursive() 
{
	int iRes;
	EnableControls( FALSE );

	// -----< sOmF >-----
	//
	// <<< t@C݊mF >>>
	if( m_lbFileList.GetCount()<=0 ){
		MessageBox( "Ώۃt@C܂B" );
		EnableControls( TRUE );
		return;
	}

	// <<< smF >>>
	iRes = MessageBox( "ċNITCY폜s܂B\n낵łH" , "mF" , MB_OKCANCEL );
	if( iRes!=IDOK ){
		EnableControls( TRUE );
		return;
	}

	// <<< s >>>
	m_bOnDeleteSmall	= TRUE;
	DoDeleteSmallRecursive( FALSE );
	m_bOnDeleteSmall	= FALSE;

	ReloadFileList();
	MessageBox( "I܂B" );
	EnableControls( TRUE );
	return;
}


int CEmiDlg::DoDeleteSmallRecursive( BOOL bDoMove )
{
	int iCheckedCount = 0;

	// -----< J[\擪 >-----
	//
	m_lbFileList.SetCurSel( 0 );
	OnSelchangeFilelist();

	// -----< JɎs >-----
	//
	while( 1 ){
		// W
		int iListCount		= m_lbFileList.GetCount();
		int iMaxIndex		= iListCount - 1;
		int iSelectedIndex	= m_lbFileList.GetCurSel();
		BOOL bIsDir			= IsDir();

		// G[mF
		if( iSelectedIndex<0 ){ break; }
		if( iMaxIndex<0      ){ break; }

		// WindowsbZ[W̏
		MSG			msg;								// Window bZ[W
		while( PeekMessage( &msg,NULL,0,0,PM_NOREMOVE ) ){		// bZ[WDispatch
			if( !GetMessage( &msg,NULL,0,0 ) )break;		// [vĨbZ[WȂI
			TranslateMessage(&msg);							// gX[g
			DispatchMessage(&msg);							// fBXpb`
		}
		if( (GetAsyncKeyState( VK_ESCAPE )&0x8000) != 0 ){
			this->m_bOnDeleteSmall	= FALSE;
		}

		// LZ
		if( this->m_bOnDeleteSmall==FALSE ){
			break;
		}

		// fBNgɈړč폜s
		BOOL bDeleteRes = FALSE;
		int iSubCheckedCount = 0;
		if( (bIsDir==FALSE) ){
			bDeleteRes = DeleteSmallPicture();
		} else {
			// fBNgɓ
			this->WalkInDirectory();

			// t@C폜
			this->DoDeleteSmallRecursive( bDoMove );
			iSubCheckedCount = this->m_lbFileList.GetCount();

			// fBNgo
			this->WalkOutDirectory();

			// eȂ΍폜
			if( iSubCheckedCount==0 ){
				CString strPath = this->GetFullPath();
				this->DoDeleteDirectory( strPath , TRUE );
				this->DeleteViewingItemFromFileList();
				bDeleteRes = TRUE;
			}
		}

		// <<< J[\ړAMove >>>
		if( bDoMove==FALSE ){
			// ړȂꍇ́AJ[\ړ̂
			if( bDeleteRes==FALSE ){
				CursorToLower();
			}
		} else {
			// ړꍇAfBNgȂJ[\ړAt@CȂړ
			if( bDeleteRes==FALSE ){
				if( IsDir()==TRUE ){
					CursorToLower();
				} else {
					BOOL bRes;
					bRes = MovePictureFile();
					if( bRes==FALSE ){
						// s珈LZ
						m_bOnDeleteSmall	= FALSE;
					}
				}
			}
		}

		// I
		if( iSelectedIndex>=iMaxIndex ){ break; }
	}

	// -----< I >-----
	//
	if( m_lbFileList.GetCount()>0 ){
		m_lbFileList.SetCurSel( 0 );
		OnSelchangeFilelist();
	}

	iCheckedCount = this->m_lbFileList.GetCount();
	return iCheckedCount;
}


//-----------------------------------------------< ċNI폜ړ >
void CEmiDlg::OnDeleteSmallRecursiveWithMove() 
{
	int iRes;
	EnableControls( FALSE );

	// -----< sOmF >-----
	//
	// <<< t@C݊mF >>>
	if( m_lbFileList.GetCount()<=0 ){
		MessageBox( "Ώۃt@C܂B" );
		EnableControls( TRUE );
		return;
	}

	// <<< smF >>>
	iRes = MessageBox( "ċNITCY폜ړs܂B\n낵łH" , "mF" , MB_OKCANCEL );
	if( iRes!=IDOK ){
		EnableControls( TRUE );
		return;
	}

	// <<< fBNgmF >>>
	BOOL bUnAvailableDir = FALSE;
	long lBaseLength	= m_strBasePath.GetLength();
	long lMoveLength	= m_strMoveDir.GetLength();

	// vꍇ́ALZ
	if( m_strBasePath.Compare( m_strMoveDir )==0 ){
		bUnAvailableDir	= TRUE;
	}

	// ܂܂Ăꍇ́ALZ
	if( lMoveLength>lBaseLength ){
		CString strCompare = m_strMoveDir.Left( lBaseLength );
		if( (strCompare.Compare( m_strBasePath )==0)
			&& (m_strMoveDir.GetAt(lBaseLength)=='\\')
		){
			bUnAvailableDir	= TRUE;
		}
	}

	// ֌WsȏꍇɃLZ
	if( bUnAvailableDir==TRUE ){
		MessageBox( "ړfBNgÃ݂fBNgɊ܂܂Ă܂B\nړɕʃfBNgw肵ĂB" );
		EnableControls( TRUE );
		return;
	}

	// <<< s >>>
	m_bOnDeleteSmall	= TRUE;
	DoDeleteSmallRecursive( TRUE );
	m_bOnDeleteSmall	= FALSE;

	ReloadFileList();
	MessageBox( "I܂B" );
	EnableControls( TRUE );
	m_lbFileList.SetFocus();
	return;
}


//-----------------------------------------------< J[\ >
BOOL CEmiDlg::CursorToLower()
{
	int iMaxIndex = m_lbFileList.GetCount()-1;
	if( m_iViewingIndex<iMaxIndex ){
		int iCursorIndex;
		iCursorIndex= m_lbFileList.GetCurSel();
		m_lbFileList.SetCurSel( iCursorIndex+1 );
		OnSelchangeFilelist();
	}
	return TRUE;
}

//-----------------------------------------------< wv\ >
void CEmiDlg::OnViewHelp() 
{
	CHelpDialog objDialog;
	objDialog.DoModal();
}

//-----------------------------------------------< fBNgɈړ >
void CEmiDlg::WalkInDirectory()
{
	// EL[Ŏ̃fBNg
	// fBNgłȂΉȂ
	if( m_lbFileList.GetCount()==0 )return;	// o^eȂ΃LZ
	if( m_lbFileList.GetItemDataPtr( m_iViewingIndex )!=(void*)(-1) )return;

	// ړ
	CString strName;					// fBNg
	int		iLength;
	m_lbFileList.GetText( m_iViewingIndex,strName );
	iLength = strName.GetLength();
	iLength -= 4;						// u[ vƁu ]v͂

	strName = strName.Mid( 2,iLength );	// fBNgo

	m_strBasePath = AddBSToDirName( (LPCTSTR)m_strBasePath );	// ̃x[XpX
	m_strBasePath += strName;									// ̃pX\z
	LoadFileList( m_strBasePath );
	OnSelchangeFilelist();
}


//-----------------------------------------------< fBNgɈړ >
void CEmiDlg::WalkOutDirectory()
{
	// L[ŐefBNg
	// fBNgłȂΉȂ
	// ݂̃fBNg擾

	CString strDir;
	strDir = RemoveBSFromDirName( (LPCTSTR)m_strBasePath );
	strDir = GetFileNameFromPath( (LPCTSTR)strDir );
	strDir = CString( "[ " ) + strDir + CString( " ]" );	// p

	// efBNg擾
	m_strBasePath = GetParentDir( (LPCTSTR)m_strBasePath );
	LoadFileList( m_strBasePath );
	m_iViewingIndex = m_lbFileList.SelectString( -1,strDir );
	if( m_iViewingIndex==-1 ){
		m_iViewingIndex = 0;
	}
	OnSelchangeFilelist();
}

//-----------------------------------------------< fBNg̃tpXԂ >
CString CEmiDlg::GetFullPath()
{
	CString strName;
	int		iLength;
	m_lbFileList.GetText( m_iViewingIndex,strName );

	if( IsDir()==TRUE ){
		iLength = strName.GetLength();
		iLength -= 4;						// u[ vƁu ]v͂
		strName = strName.Mid( 2,iLength );	// fBNgo
	}

	CString strResult = AddBSToDirName( (LPCTSTR)m_strBasePath );	// ̃x[XpX
	strResult += strName;									// ̃pX\z

	return strResult;
}

//-----------------------------------------------< GUIRg[̗pݒ >
void CEmiDlg::EnableControls( BOOL bSw )
{
	this->m_lbFileList.EnableWindow( bSw );
	this->m_btnChangeDir.EnableWindow( bSw );
}

//-----------------------------------------------< WindowsbZ[W >
void CEmiDlg::DoDispatchWindowsMessage()
{
	// WindowsbZ[W̏
	MSG			msg;								// Window bZ[W
	while( PeekMessage( &msg,NULL,0,0,PM_NOREMOVE ) ){		// bZ[WDispatch
		if( !GetMessage( &msg,NULL,0,0 ) )break;		// [vĨbZ[WȂI
		TranslateMessage(&msg);							// gX[g
		DispatchMessage(&msg);							// fBXpb`
	}
}
