#include "FileNameUtil.h"
#include "Str.h"

//------------------------------------------------< gq擾 >
//
CString GetExtension( const char* pFName )
{
	// gqo
	const char* pExt = pFName;
	while( 1 ){
		unsigned char* pWork;
		pWork = _mbschr( (const unsigned char*)pExt,'.' );
		if( pWork==NULL )break;
		pExt = (const char*)pWork + CGStr::GetMBLetterSize( (const char*)pWork );
	}

	// ŁApExt ͊gqwĂB gqꍇ pFName ̐擪wB
	if( pExt==pFName )return CString( "" );			// gqꍇ

	// ʂ啶ɕϊĕԂ
	CString strRes;
	strRes = CString( pExt );
	strRes.MakeUpper();
	return strRes;									// gqꍇ
}


//------------------------------------------------< x[XfBNg擾 >
//
CString GetBaseDir( const char* pPathName )
{
	// x[XpX擾B
	// [input]							[output]
	// sample.txt						[null]
	// c:sample.txt						c:
	// c:\sample.txt					c:\
	// c:\dir1\sample.txt				c:\dir1\
	// c:dir1\sample.txt				c:dir1\
	// dir1\sample.txt					dir1\

	BOOL	bExistBS = FALSE;						// obNXbV̐
	const char*	pName;								// p|C^
	pName = pPathName;

	// Ō̃obNXbVT
	while( 1 ){
		unsigned char* pBS;
		pBS = _mbschr( (const unsigned char*)pName,'\\' );					// u\v
		if( pBS==NULL )break;						// I
		pName		= (const char*)pBS + 1;						// u\v̎ֈړ
		bExistBS	= TRUE;							// u\v݂͑B
	}

	// ŁApName ͍Ṓu\v̎wBu\vƂ pPathName ̐擪wB

	// u\v݂ȂꍇAu:v΃hCu܂łx[XfBNgƂB
	// u:v΁AkpXƂĕԂB
	CString	strRes;									// ʕ

	if( bExistBS==FALSE ){
		if( _mbschr( (const unsigned char*)pName,':' )==NULL ){			// u:vȂ΃kԂ
			strRes = CString( "" );
		} else {									// u:v
			CString strRes;
			strRes		= CString( "?:" );			// u?:vƂĂ
			strRes.SetAt( 0,pName[0] );				// hCu^[u?vɏ㏑B
		}
		return strRes;
	}


	// u\v݂ꍇ́AṒu\v܂łԂB
	int i=0;
	char cPathName[_MAX_PATH];
	memset( cPathName,0,sizeof( cPathName ) );
	while( pPathName!=pName ){						// ̃Rs[
		cPathName[i++] = *pPathName++;
	}

	strRes = CString( cPathName );
	return strRes;
}


//------------------------------------------------< ̍ŌɁu\vǉ >
//
CString AddBSToDirName( const char* pDirName )
{
	// c:					c:
	// c:sample				c:sample\
	// c:sample\			c:sample\
	// c:\					c:\
	// c:\sample			c:\sample\
	// c:\sample\			c:\sample\
	// sample				sample\
	// sample\				sample\


	// w蕶񂪂QŁAQڂu:vȂhCuȂ̂ŁÂ܂ܕԂ
	if( strlen( pDirName )==2 ){					// pXQ
		if( pDirName[1]==':' ){						// Qڂu:vȂhCûݎw
			return CString( pDirName );
		}
	}

	// 
	BOOL	bExistBS = FALSE;						// obNXbV̐
	const char*	pName;								// p|C^
	pName = pDirName;

	// Ō̃obNXbVT
	while( 1 ){
		unsigned char* pBS;
		pBS = _mbschr( (const unsigned char*)pName,'\\' );					// u\v
		if( pBS==NULL )break;						// I
		pName		= (const char*)pBS+1;						// u\v̎ֈړ
		bExistBS	= TRUE;							// u\v݂͑B
	}

	// ŁApName ͍Ṓu\v̎wBu\vƂ pDirName ̐擪wB

	// u\vꍇ́Â܂܍ŌɁu\vĕԂB
	if( bExistBS==FALSE ){
		CString strRes;
		strRes = CString( pDirName );
		strRes = strRes + CString( "\\" );
		return strRes;
	}

	// ŌɁu\vΒǉB
	if( *pName=='\0' ){								// pNamëʒuI[LȂ炻̂܂ܕԂ
		return CString( pDirName );
	}

	CString strRes;
	strRes = CString( pDirName );
	strRes = strRes + CString( "\\" );
	return strRes;
}


//-----------------------------------------------< pX̍Ṓu\v >
//
CString RemoveBSFromDirName( const char* pDirName )
{
	// c:\					c:\
	// c:					c:
	// c:sample				c:sample
	// c:sample\			c:sample
	// c:\sample			c:\sample
	// c:\sample\			c:\sample
	// sample				sample
	// sample\				sample

	// uc:\vȂǂ̃p^[ł́Â܂܁u\vɕԂB
	if( strlen( pDirName )==3 ){
		if( (pDirName[1]==':')&&(pDirName[2]=='\\') ){
			return CString( pDirName );
		}
	}

	// Ƃ肠Rs[
	char cName[_MAX_PATH];							// ߂l̃pX
	memset( cName,0,sizeof( cName ) );
	strcpy( cName,pDirName );						// pXRs[

	// Ō̃obNXbṼ|C^𓾂BɃobNXbV̐𐔂B
	int iNumBS = 0;									// obNXbV̐
	char* pBS = cName;								// obNXbVւ̃|C^

	// 肩
	while( 1 ){
		unsigned char* pWork;
		pWork = _mbschr( (const unsigned char*)pBS,'\\' );					// u\vT
		if( pWork==NULL )break;						// ȂΏI

		pBS = (char*)pWork+1;								// u\v̎̈ʒu
		iNumBS += 1;
	}

	// obNXbVȂ΁Â܂ܕԂ
	if( iNumBS==0 ){
		return CString( pDirName );
	}

	// Ō̃obNXbV̎I[LȂAobNXbV
	if( *pBS=='\0' ){
		pBS--;
		*pBS = '\0';
	}

	return CString( cName );
}


//-----------------------------------------------< tpX󂯎AefBNgԂ >
//
CString GetParentDir( const char* pDirName )
{
	// uc:\vȂǂ̃p^[ȂÂ܂ܕԂ
	if( strlen( pDirName )==3 ){
		if( (pDirName[1]==':')&&(pDirName[2]=='\\') ){
			return CString( pDirName );
		}
	}

	// fBNg̍Ṓu\vΏ
	CString strPath;
	strPath = RemoveBSFromDirName( pDirName );

	// Ƃ肠Rs[
	char cName[_MAX_PATH];
	memset( cName,0,sizeof( cName ) );
	strcpy( cName,(LPCTSTR)strPath );

	// u\vTA𐔂
	char* pBS = cName;							// obNXbV̈ʒuT|C^
	int	iNum = 0;								// obNXbV̐

	// Ō܂Ō
	while( 1 ){
		unsigned char* pWork;							// Ɨp
		pWork = _mbschr( (const unsigned char*)pBS,'\\' );			// u\v̈ʒuɔ
		if( pWork==NULL )break;					// ȂΏI

		pBS = (char*)pWork+1;							// obNXbV̎ֈړ
		iNum += 1;								// obNXbVP
	}

	// obNXbVȂ΁Au..vĕԂiꉞj
	if( iNum==0 ){
		return CString( pDirName )+CString( "\\..\\" );
	}

	// obNXbV̒ɏI[LāA̕Jbg
	*pBS = '\0';
	return CString( cName );
}


//-----------------------------------------------< tpX̃t@Co >
//
CString GetFileNameFromPath( const char* pPathName )
{
	// Ƃ肠ARs[
	char cName[_MAX_PATH];
	memset( cName,0,sizeof( cName ) );
	strcpy( cName,pPathName );

	// Ō̃obNXbV܂Ŕ΂
	char* pBS = cName;
	while( 1 ){
		unsigned char* pWork;
		pWork = _mbschr( (const unsigned char*)pBS,'\\' );
		if( pWork==NULL )break;

		pBS = (char*)pWork+1;
	}

	// t@CԂ
	return CString( pBS );
}

//------------------------------------------------< gqւ >
//
CString ReplaceExtension( const char* pFName,const char* pNewExt )
{
	// gqo
	const char* pExt = pFName;
	while( 1 ){
		unsigned char* pWork;
		pWork = _mbschr( (const unsigned char*)pExt,'.' );
		if( pWork==NULL )break;
		pExt = (const char*)pWork+1;
	}

	// ŁApExt ͊gqwĂB gqꍇ pFName ̐擪wB
	if( pExt==pFName ){									// gqꍇ́Â܂܌ɂĕԂ
		return CString( pFName ) + CString( "." ) + CString( pNewExt );
	}

	// ̃Rs[
	int iMainLength;									// t@C + "." ̒
	iMainLength	= pExt - pFName;

	char* pMainBuffer , *pMainWork;
	pMainBuffer	= (char*)malloc( iMainLength+1 );
	if( pMainBuffer==NULL )return CString( pFName );	// mێs
	pMainWork = pMainBuffer;
	for( int i=0;i<iMainLength;i++ ){					// Rs[
		*pMainWork++ = pFName[i];
	}
	*pMainWork = 0;										// GhR[h

	// ʂĕԂ
	CString strRes;
	strRes = CString( pMainBuffer ) + CString( pNewExt );
	free( pMainBuffer );
	return strRes;
}
