// JumpDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Emi.h"
#include "JumpDialog.h"
#include "NewDirDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJumpDialog _CAO


CJumpDialog::CJumpDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CJumpDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJumpDialog)
	m_strSelectedDir = _T("");
	m_strPathName = _T("");
	//}}AFX_DATA_INIT
}


void CJumpDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJumpDialog)
	DDX_Control(pDX, IDC_DIRLIST, m_lbDirList);
	DDX_LBString(pDX, IDC_DIRLIST, m_strSelectedDir);
	DDX_Text(pDX, IDC_PATHNAME, m_strPathName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJumpDialog, CDialog)
	//{{AFX_MSG_MAP(CJumpDialog)
	ON_BN_CLICKED(IDC_ADDCURRENT, OnAddcurrent)
	ON_BN_CLICKED(IDC_DELETEITEM, OnDeleteitem)
	ON_LBN_SELCHANGE(IDC_DIRLIST, OnSelchangeDirlist)
	ON_BN_CLICKED(IDC_EDITNAME, OnEditname)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJumpDialog bZ[W nh

void CJumpDialog::OnAddcurrent() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// VKo^_CAO쐬
	CNewDirDialog dlg;
	dlg.m_strExplain	= m_strCurrentPath;				// Jg̃pXZbg
	if( dlg.DoModal()==IDCANCEL ){
		return;								// LZȂ牽ȂŕԂB
	}

	// ʂ̃fBNg擾
	CString strNewName;
	strNewName	= dlg.m_strExplain;

	// Vvfǉ
	int iListIndex	= m_lbDirList.AddString( (LPCTSTR)strNewName );			// Xgɒǉ
	int iArrayIndex	= m_arrayPath.Add( (LPCTSTR)m_strCurrentPath );			// zɒǉ
	m_lbDirList.SetItemData( iListIndex,iArrayIndex );						// XgɑΉCfbNX

	// 
	CString strNum;
	strNum	= CreateNumString( iArrayIndex + 1 );

	// init@Cɏ
	// L[̍쐬
	CString strKey	= CreateKeyName( iArrayIndex );

	// 
	WritePrivateProfileString( "RegistedDirNum"  , "Num" , (LPCTSTR)strNum , m_strIniPath );
	WritePrivateProfileString( "RegistedDirPath" , (LPCTSTR)strKey , m_strCurrentPath , m_strIniPath );
	WritePrivateProfileString( "RegistedDirName" , (LPCTSTR)strKey , strNewName , m_strIniPath );

	// IpXɂďI
	m_strPathName.Empty();
	OnCancel();
}

//-----------------------------------------------< _CAO >
BOOL CJumpDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	LoadDirList();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//-----------------------------------------------< fBNgXg̓ǂݍ >
void CJumpDialog::LoadDirList()
{
	// ܂
	m_strPathName.Empty();						// pX
	m_arrayPath.SetSize( 0,10 );				// pXz
	m_lbDirList.ResetContent();					// Xg{bNXNA

	// f[^ǂݍ
	// ̎擾
	char pNumString[100];
	GetPrivateProfileString( "RegistedDirNum" , "Num" , "0" , pNumString , sizeof( pNumString ) , m_strIniPath );

	// 𐔒l
	int	iNum;
	iNum = atoi( (LPCTSTR)pNumString );
	if( iNum<=0 )return;						// O}CiXȂÂ܂ܕԂB

	// fBNgz̃TCY߂
	m_arrayPath.SetSize( iNum );

	// ACeǂݍ
	for( int i=0;i<iNum;i++ ){
		CString strKey	= CreateKeyName( i );

		// f[^ǂݍ
		char	cDirPath[_MAX_PATH];
		char	cDirName[1024];
		GetPrivateProfileString( "RegistedDirPath" , strKey , "" , cDirPath , sizeof( cDirPath ) , m_strIniPath );
		GetPrivateProfileString( "RegistedDirName" , strKey , "" , cDirName , sizeof( cDirName ) , m_strIniPath );

		// f[^z^Xgɓ
		int iIndex;
		iIndex	= m_lbDirList.AddString( cDirName );		// Xgɕǉ
		m_lbDirList.SetItemData( iIndex , i );				// ǉꂽɁAΉpX̃CfbNXZbg
		m_arrayPath.SetAt( i , CString( cDirPath ) );		// fBNgɑΉpXZbg
	}

	// 擪̍ڂI
	m_lbDirList.SetCurSel( 0 );
	m_lbDirList.SetFocus();
	OnSelchangeDirlist();
}

//-----------------------------------------------< ACe폜 >
void CJumpDialog::OnDeleteitem() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// IĂCfbNX擾
	int iListIndex;
	iListIndex	= m_lbDirList.GetCurSel();
	if( iListIndex==LB_ERR ){					// IڂȂÂ܂ܕԂ
		return;
	}

	// init@C̃fBNg݂̃f[^S
	// ̎擾
	char pNumString[100];
	GetPrivateProfileString( "RegistedDirNum" , "Num" , "0" , pNumString , sizeof( pNumString ) , m_strIniPath );

	// 𐔒l
	int	iNum;
	iNum = atoi( (LPCTSTR)pNumString );
	if( iNum<=0 )return;						// O}CiXȂÂ܂ܕԂB

	// f[^폜
	for( int i=0;i<iNum;i++ ){
		CString strKey	= CreateKeyName( i );

		// f[^폜
		WritePrivateProfileString( "RegistedDirPath" , strKey , NULL , m_strIniPath );
		WritePrivateProfileString( "RegistedDirName" , strKey , NULL , m_strIniPath );
	}


	// f[^
	iNum = 0;
	for( i=0;i<m_lbDirList.GetCount();i++ ){
		if( i==iListIndex )continue;

		// L[쐬
		CString	strKey;
		strKey	= CreateKeyName( iNum );

		// f[^
		CString strName;
		m_lbDirList.GetText( i , strName );

		int iIdx;
		iIdx	= m_lbDirList.GetItemData( i );
		WritePrivateProfileString( "RegistedDirPath" , strKey , (LPCTSTR)(m_arrayPath.ElementAt( iIdx )) , m_strIniPath );
		WritePrivateProfileString( "RegistedDirName" , strKey , strName , m_strIniPath );

		iNum += 1;
	}

	// 
	CString strNum;
	strNum	= CreateNumString( iNum );
	WritePrivateProfileString( "RegistedDirNum" , "Num" , (LPCTSTR)strNum , m_strIniPath );

	// f[^[h
	LoadDirList();
}

//-----------------------------------------------< L[ >
CString CJumpDialog::CreateKeyName(int iNum)
{
	// ֕ϊ
	char cNum[33];
	itoa( iNum , cNum , 10 );

	// g~O
	CString strNum;
	strNum	= CString( cNum );
	strNum.TrimLeft();
	strNum.TrimRight();

	// Ċ
	CString strKey;
	strKey	= CString( "Dir" ) + strNum;

	return strKey;
}

//-----------------------------------------------< Num 쐬 >
CString CJumpDialog::CreateNumString( int iNum )
{
	// ֕ϊ
	char cNum[33];
	itoa( iNum , cNum , 10 );

	// g~O
	CString strNum;
	strNum	= CString( cNum );
	strNum.TrimLeft();
	strNum.TrimRight();

	// ʂԂ
	return strNum;
}

//-----------------------------------------------< IύXꂽƂ̏ >
void CJumpDialog::OnSelchangeDirlist() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// IĂJ[\CfbNX
	int iIndex;
	iIndex	= m_lbDirList.GetCurSel();

	// J[\̑IG[ȂAIpXɂB
	if( iIndex==LB_ERR ){
		m_strPathName.Empty();
	}

	// IĂpXݒ
	int iArrayIndex;
	iArrayIndex	= m_lbDirList.GetItemData( iIndex );
	m_strPathName = m_arrayPath.ElementAt( iArrayIndex );
	UpdateData( FALSE );
	return;
}

void CJumpDialog::OnEditname() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// I𒆂̃CfbNX擾
	int iIndex;
	iIndex	= m_lbDirList.GetCurSel();
	if( iIndex==LB_ERR ){					// IȂ炻̂܂ܕԂ
		return;
	}

	// VKo^_CAO쐬
	CNewDirDialog dlg;
	m_lbDirList.GetText( iIndex , dlg.m_strExplain );
	if( dlg.DoModal()==IDCANCEL ){
		return;								// LZȂ牽ȂŕԂB
	}

	// ʂ̃fBNg擾
	CString strNewName;
	strNewName	= dlg.m_strExplain;

	// ֘AÂꂽl擾
	DWORD	dwArrayIndex;
	dwArrayIndex	= m_lbDirList.GetItemData( iIndex );

	// ܂ACe폜
	m_lbDirList.DeleteString( iIndex );

	// VɃACeǉ
	iIndex	= m_lbDirList.AddString( strNewName );				// O
	m_lbDirList.SetItemData( iIndex , dwArrayIndex );			// pXz̃CfbNX

	// ini t@Cւ̏
	CString strKey	= CreateKeyName( dwArrayIndex );
	WritePrivateProfileString( "RegistedDirPath" , strKey , (LPCTSTR)(m_arrayPath.ElementAt( dwArrayIndex )) , m_strIniPath );
	WritePrivateProfileString( "RegistedDirName" , strKey , strNewName , m_strIniPath );

	// Xg{bNXɃtH[JX߂
	m_lbDirList.SetFocus();
	m_lbDirList.SetCurSel( iIndex );
	OnSelchangeDirlist();
}
