#include <windows.h>
#include <stdio.h>

#include "Str.h"
#include "DArray.h"

#include "SpiUnit.h"

//------------------------------------------------< RXgN^ >
//
CSpiUnit::CSpiUnit()
{
	// f[^̏
	m_hSpi		= NULL;						// W[nh
	m_pSpiPath	= NULL;						// roh̃pX
	m_iTypeNum	= 0;						// ΉĂgq̐

	m_hBmpBits	= NULL;						// rbgz̃nh
	m_hBmpInfo	= NULL;						// BMPINFO i[̈̃nh

	for( int i=0;i<_MAX_TYPEEXT;i++ )memset( m_aTypeExtension[i],0,_MAX_PATH );
	memset( m_cFileName,0,sizeof( m_cFileName ) );
	memset( &m_sPictureInfo,0,sizeof( PictureInfo ) );
}


//-----------------------------------------------< Rs[RXgN^ >
//
CSpiUnit::CSpiUnit( CSpiUnit& refSpiUnit )
{
	// f[^̏
	m_hSpi		= NULL;						// W[nh
	m_pSpiPath	= NULL;						// roh̃pX
	m_iTypeNum	= 0;						// ΉĂgq̐

	m_hBmpBits	= NULL;						// rbgz̃nh
	m_hBmpInfo	= NULL;						// BMPINFO i[̈̃nh

	for( int i=0;i<_MAX_TYPEEXT;i++ )memset( m_aTypeExtension[i],0,_MAX_PATH );
	memset( m_cFileName,0,sizeof( m_cFileName ) );
	memset( &m_sPictureInfo,0,sizeof( PictureInfo ) );

	// ̌̏
	Free();										// Ƃ肠
	if( refSpiUnit.m_hSpi==NULL )return;		// rohǂݍݑOȂA܂łłnj

	Load( refSpiUnit.m_pSpiPath );				// roh̓ǂݍ
	if( refSpiUnit.m_cFileName[0]!='\0' ){		// 炩̃t@Cǂ܂ĂȂ
		LoadPicture( refSpiUnit.m_cFileName );	// ǂ
	}

	return;
}


//-----------------------------------------------< = Iy[^ >
//
CSpiUnit& CSpiUnit::operator=( CSpiUnit& refSpiUnit )
{
	Free();										// Ƃ肠
	if( refSpiUnit.m_hSpi==NULL )return *this;	// rohǂݍݑOȂA܂łłnj

	Load( refSpiUnit.m_pSpiPath );				// roh̓ǂݍ
	if( refSpiUnit.m_cFileName[0]!='\0' ){		// 炩̃t@Cǂ܂ĂȂ
		LoadPicture( refSpiUnit.m_cFileName );	// ǂ
	}

	return *this;
}


//------------------------------------------------< fXgN^ >
//
CSpiUnit::~CSpiUnit()
{
	// 
	Free();									// 
}


//------------------------------------------------< roh̃[h >
//
BOOL CSpiUnit::Load( char* pSpiPath )
{
	// 
	if( m_hSpi!=NULL )Free();							// Ƃ肠

	// [h
	m_hSpi	= LoadLibrary( pSpiPath );					// roh[h
	if( m_hSpi==NULL )return FALSE;						// sȂ FALSE

	// pXi[
	m_pSpiPath = (char*)malloc( strlen( pSpiPath )+1 );	// i[pm
	if( m_pSpiPath==NULL ){								// mێsȂSs
		Free();
		return FALSE;
	}
	strcpy( m_pSpiPath,pSpiPath );						// pXRs[


	// gq֘Aobt@m
	char cSpiExt[_MAX_PATH];							// SPI̊gq
	GetPluginInfo	SpiFunc;							// ֐

	// ֐o
	SpiFunc = (GetPluginInfo)GetProcAddress( m_hSpi,"GetPluginInfo" );
	if( SpiFunc==NULL ){					// o[Wu??INvłȂΎgȂB
		Free();
		return FALSE;
	}

	// o[Wԍo
	char cVer[5];
	SpiFunc( 0,cVer,5 );
	if( (cVer[2]!='I')||(cVer[3]!='N') ){
		Free();
		return FALSE;
	}

	// gqo^
	for( int i=2;i<2+(_MAX_TYPEEXT*2);i+=2 ){			// I܂ŌJԂ
		int iRes;
		iRes = SpiFunc( i,cSpiExt,_MAX_PATH );			// ^Cv擾
		if( iRes==0 )break;								// ԍ i ɂȂI
		m_iTypeNum += 1;

		// gq̑啶ւ̕ϊ
		for( UINT j=0;j<strlen( cSpiExt );j++ )cSpiExt[j] = toupper( cSpiExt[j] );

		// gqɒǉ
		strcpy( m_aTypeExtension[(i/2)-1],&(cSpiExt[2]) );
	}

	// I
	return TRUE;
}


//------------------------------------------------<  >
//
void CSpiUnit::Free()
{
	// 
	FreePicture();
	if( m_hSpi )FreeLibrary( m_hSpi );					// CuJ
	if( m_pSpiPath )free( m_pSpiPath );					// pX

	// ϐ̏
	m_hSpi = NULL;										// Cũnh
	m_pSpiPath = NULL;									// pX
	m_iTypeNum = 0;										// Ήgq̐͂O
	for( int i=0;i<_MAX_TYPEEXT;i++ ){					// gqz
		memset( m_aTypeExtension[i],0,_MAX_PATH );
	}
}


//-----------------------------------------------< ΉĂgq̐Ԃ >
//
int CSpiUnit::GetTypeNum()
{
	return m_iTypeNum;
}


//-----------------------------------------------< ΉĂgq̕Ԃ >
//
char* CSpiUnit::GetTypeExtension( int iIndex )
{
	// z̃TCY傫ȂNULLԂ
	if( iIndex >= m_iTypeNum )return NULL;

	// ʂԂ
	return m_aTypeExtension[iIndex];
}


//------------------------------------------------< ΉĂ^Cv >
//
BOOL CSpiUnit::IsType( const char* pExt )
{
	// G[`FbN
	if( m_hSpi==NULL )return FALSE;						// OȂG[

	// gqi[obt@m
	char cSpiExt[_MAX_PATH];							// SPI̊gq
	char cPrmExt[_MAX_PATH];							// p[^Ƃēnꂽgq
	GetPluginInfo	SpiFunc;							// ֐

	// gqv邩mF
	BOOL bRes;
	bRes = FALSE;

	// ֐o
	SpiFunc = (GetPluginInfo)GetProcAddress( m_hSpi,"GetPluginInfo" );
	if( SpiFunc==NULL )return FALSE;

	// r
	int i=2;
	unsigned int j;
	while( 1 ){											// I܂ŌJԂ
		int iRes;
		iRes = SpiFunc( i,cSpiExt,_MAX_PATH );			// ^Cv擾
		if( iRes==0 )break;								// ԍ i ɂȂI
		i+=2;

		// gq̑啶ւ̕ϊ
		for( j=0;j<strlen( cSpiExt );j++ )cSpiExt[j] = toupper( cSpiExt[j] );
		for( j=0;j<strlen( pExt )+1 ;j++ )cPrmExt[j] = toupper( pExt[j]    );

		// 
		CGStr strTypes = cSpiExt;
		CDStringArray	aryElements;
		strTypes.Explode( ";" , aryElements );

		int c;
		for( c=0;c<aryElements.Length();c++ ){
			CGStr strExt		= aryElements[ c ];
			const char* pExt	= strExt.GetString() + 2;
			// gq̔r
			if( strcmp( pExt,cPrmExt )==0 ){		// vI
				bRes = TRUE;
				break;
			}
		}
		if( bRes==TRUE ){
			break;
		}
	}

	// ʂԂ
	return bRes;
}


//------------------------------------------------< 摜̓ǂݍ >
//
BOOL CSpiUnit::LoadPicture( const char* pFName )
{
	int				iRes;									// 

	// ɓǂݍ܂ĂA܂͉
	FreePicture();

	// 摜̎o
	GetPictureInfo	fGetPictureInfo;						// ֐
	fGetPictureInfo = (GetPictureInfo)GetProcAddress( m_hSpi,"GetPictureInfo" );
	if( fGetPictureInfo==NULL )return FALSE;

	iRes = fGetPictureInfo( (char*)pFName,0,0,&m_sPictureInfo );
	if( iRes!=0 )return FALSE;

	// 摜̎o
	GetPicture fGetPicture;									// ֐
	fGetPicture = (GetPicture)GetProcAddress( m_hSpi,"GetPicture" );
	if( fGetPicture==NULL )return FALSE;

	iRes = fGetPicture( (char*)pFName,0,0,&m_hBmpInfo,&m_hBmpBits,NULL,0 );
	if( iRes!=0 )return FALSE;

	// 舵̃t@Cݒ
	strcpy( m_cFileName,pFName );

	// I
	return TRUE;
}


//------------------------------------------------< 摜j >
//
void CSpiUnit::FreePicture()
{
	if( m_hBmpInfo )LocalFree( m_hBmpInfo );
	if( m_hBmpBits )LocalFree( m_hBmpBits );
	m_hBmpInfo = NULL;
	m_hBmpBits = NULL;

	memset( m_cFileName,0,sizeof( m_cFileName ) );
	memset( &m_sPictureInfo,0,sizeof( PictureInfo ) );
}


//-----------------------------------------------< Ԃ >
//
long CSpiUnit::GetWidth()
{
	if( m_hBmpInfo==NULL )return 0L;				// OȂ 0 Ԃ
	return m_sPictureInfo.width;
}


//-----------------------------------------------< Ԃ >
//
long CSpiUnit::GetHeight()
{
	if( m_hBmpInfo==NULL )return 0L;				// OȂ 0 Ԃ
	return m_sPictureInfo.height;
}


//------------------------------------------------< ʂɕ` >
//
BOOL CSpiUnit::NormalDraw( char* pFName,HDC hDC,int iX,int iY )
{
	BOOL bRes;

	// 摜̓ǂݍ
	bRes = LoadPicture( pFName );
	if( bRes==FALSE )return FALSE;

	// 摜̕\
	bRes = NormalDraw( hDC,iX,iY );

	// 摜̔j
	FreePicture();											// 摜j

	// ʂԂ
	return bRes;
}


//------------------------------------------------< ʂɕ`iłɓǂ񂾉摜`j >
//
BOOL CSpiUnit::NormalDraw( HDC hDC,int iX,int iY )
{
	int				iRes;									// 

	// 摜ǂ܂ĂȂ΁Â܂ܕԂ
	if( m_hBmpInfo==NULL )return TRUE;
	if( m_hBmpBits==NULL )return TRUE;

	// 摜̕\
	LPBITMAPINFO	pBmpInfo;								// BMPINFO \̂ւ̃|C^
	LPBYTE			pBmpBits;								// rbgzւ̃|C^
	pBmpInfo	= (LPBITMAPINFO)::LocalLock(m_hBmpInfo);
	pBmpBits	= (LPBYTE)::LocalLock(m_hBmpBits);

	int	oldSSBM = SetStretchBltMode( hDC,COLORONCOLOR );
	int nOldMap = SetMapMode( hDC,MM_TEXT );

	LPBITMAPINFOHEADER pBmpInfoHeader = &(pBmpInfo->bmiHeader);
	iRes = StretchDIBits(
					hDC,										//  hDC
					iX,											//	DestX
					iY,											//	DestY
					pBmpInfoHeader->biWidth, 					//	DestWidth
					pBmpInfoHeader->biHeight,					//	DestHeight
					0,											//	SrcX
					0, 											//	SrcY
					pBmpInfoHeader->biWidth, 					//	SrcWidth
					pBmpInfoHeader->biHeight,					//	nNumScans
					pBmpBits,									//	lpBits
					pBmpInfo,									//	lpBitsInfo
					DIB_RGB_COLORS,								//	wUsage
					SRCCOPY );									//	dwROP

	SetStretchBltMode( hDC,oldSSBM );
	SetMapMode( hDC,nOldMap );

	LocalUnlock( m_hBmpInfo );
	LocalUnlock( m_hBmpBits );

	// ʂԂ
	if( iRes==GDI_ERROR )return FALSE;						// `Ɏsꍇ FALSE
	return TRUE;
}


//------------------------------------------------< g^k` >
//
BOOL CSpiUnit::StretchDraw( char* pFName,HDC hDC,LPRECT pSrcRect,LPRECT pDstRect )
{
	BOOL bRes;

	// 摜̓ǂݍ
	bRes = LoadPicture( pFName );
	if( bRes==FALSE )return FALSE;

	// 摜̕\
	bRes = StretchDraw( hDC,pSrcRect,pDstRect );

	// 摜̔j
	FreePicture();											// 摜j

	// ʂԂ
	return bRes;
}


//------------------------------------------------< g^k`iłɓǂ񂾉摜`j >
//
BOOL CSpiUnit::StretchDraw( HDC hDC,LPRECT pSrcRect,LPRECT pDstRect )
{
	int				iRes;									// 

	// 摜ǂ܂ĂȂ΁Â܂ܕԂ
	if( m_hBmpInfo==NULL )return TRUE;
	if( m_hBmpBits==NULL )return TRUE;

	// 摜̕\
	LPBITMAPINFO	pBmpInfo;								// BMPINFO \̂ւ̃|C^
	LPBYTE			pBmpBits;								// rbgzւ̃|C^
	pBmpInfo	= (LPBITMAPINFO)::LocalLock(m_hBmpInfo);
	pBmpBits	= (LPBYTE)::LocalLock(m_hBmpBits);

	int	oldSSBM = SetStretchBltMode( hDC,COLORONCOLOR );
	int nOldMap = SetMapMode( hDC,MM_TEXT );

	LPBITMAPINFOHEADER pBmpInfoHeader = &(pBmpInfo->bmiHeader);
	iRes = StretchDIBits(
					hDC,										//  hDC
					pDstRect->left,								//	DestX
					pDstRect->top,								//	DestY
					pDstRect->right  - pDstRect->left, 			//	DestWidth
					pDstRect->bottom - pDstRect->top,			//	DestHeight
					pSrcRect->left,								//	SrcX
					pSrcRect->top,								//	SrcY
					pSrcRect->right  - pSrcRect->left, 			//	SrcWidth
					pSrcRect->bottom - pSrcRect->top,			//	nNumScans
					pBmpBits,									//	lpBits
					pBmpInfo,									//	lpBitsInfo
					DIB_RGB_COLORS,								//	wUsage
					SRCCOPY );									//	dwROP

	SetStretchBltMode( hDC,oldSSBM );
	SetMapMode( hDC,nOldMap );

	LocalUnlock( m_hBmpInfo );
	LocalUnlock( m_hBmpBits );

	// ʂԂ
	if( iRes==GDI_ERROR )return FALSE;						// `Ɏsꍇ FALSE
	return TRUE;
}

//-----------------------------------------------< aloŃZ[u >
BOOL CSpiUnit::SaveBMP( const char *pFName )
{
	// bN
	LPBITMAPINFO	pBmpInfo;								// BMPINFO \̂ւ̃|C^
	LPBYTE			pBmpBits;								// rbgzւ̃|C^
	pBmpInfo	= (LPBITMAPINFO)::LocalLock(m_hBmpInfo);
	pBmpBits	= (LPBYTE)::LocalLock(m_hBmpBits);

	// FvZ
	int	iColorDepth;								// J[fvX
	iColorDepth	= m_sPictureInfo.colorDepth;

	int iRQNum;										// RGBQUAD ̐
	if( iColorDepth<=8 )iRQNum	= 1<<iColorDepth;
	else	iRQNum	= 0;

	// C[W̑傫vZ
	UINT uRasterSize , uImageSize;
	uRasterSize	 = ( GetWidth() * iColorDepth )/8;		// oCg
	uRasterSize += ( 4-(uRasterSize&3) )&3;				// SoCgE
	uImageSize	 = uRasterSize * GetHeight();			// đŜ̃TCY

	// wb_
	BITMAPFILEHEADER	bmfh;

	// BMPFILEHEADER ̍\z
	bmfh.bfType			= 0x4D42;
	bmfh.bfSize			= sizeof( BITMAPFILEHEADER )
						+ sizeof( BITMAPINFOHEADER )
						+ ( sizeof( RGBQUAD ) * iRQNum )
						+ uImageSize;
	bmfh.bfReserved1	= 0;
	bmfh.bfReserved2	= 0;
	bmfh.bfOffBits		= sizeof( BITMAPFILEHEADER )
						+ sizeof( BITMAPINFOHEADER )
						+ ( sizeof( RGBQUAD ) * iRQNum );

	// 摜̃Z[u
	FILE*	pStream;
	pStream	= fopen( pFName , "wb" );
	if( pStream==NULL ){
		LocalUnlock( m_hBmpInfo );
		LocalUnlock( m_hBmpBits );
		return FALSE;
	}

	fwrite( &bmfh                , sizeof( BITMAPFILEHEADER ) , 1 , pStream );
	fwrite( &pBmpInfo->bmiHeader , sizeof( BITMAPINFOHEADER ) , 1 , pStream );
	if( iRQNum!=0 ){
		fwrite( pBmpInfo->bmiColors  , sizeof( RGBQUAD ) * iRQNum , 1 , pStream );
	}
	fwrite( pBmpBits             , uImageSize                 , 1 , pStream );
	fclose( pStream );

	LocalUnlock( m_hBmpInfo );
	LocalUnlock( m_hBmpBits );

	// I
	return TRUE;
}

//-----------------------------------------------< ǎpaloƂăZ[u >
// bStretch  TRUE ̂Ƃ́ASystemMetrics ʂ̃TCY擾
// ̑傫ɃAXyNg䂪ςȂ悤ɃXgb`Z[uB
//-------------------------------------------------------------------------------
BOOL CSpiUnit::SaveAsWallPaper( const char *pFName, BOOL bStretch)
{
	// ʂ̃TCY擾
	int	iScreenWidth;
	int	iScreenHeight;
	iScreenWidth	= GetSystemMetrics( SM_CXSCREEN );
	iScreenHeight	= GetSystemMetrics( SM_CYSCREEN );

	// AXyNg(Width/Height) * 10000 擾
	int iScreenARatio;
	iScreenARatio	= ( iScreenWidth*10000 ) / iScreenHeight;

	// 摜̃TCY擾
	int iPictureWidth;
	int iPictureHeight;
	iPictureWidth	= GetWidth();
	iPictureHeight	= GetHeight();

	// AXyNg(Width/Height) * 10000 擾
	int iPictureARatio;
	iPictureARatio	= ( iPictureWidth * 10000 ) / iPictureHeight;

	// o͉摜TCYvZ
	int iBmpWidth;
	int	iBmpHeight;

	if( iPictureARatio > iScreenARatio ){	// XN[摜̕ɒꍇ
		iBmpWidth	= iPictureWidth;		// ͂̂܂
		iBmpHeight	= ( iScreenHeight*iPictureWidth ) / iScreenWidth;	// ScrHeight * ( PicWidth / ScrWidth )
	} else {								// 摜XN[̕ɒꍇ
		iBmpHeight	= iPictureHeight;		// ͂̂܂
		iBmpWidth	= ( iScreenWidth*iPictureHeight ) / iScreenHeight;	// ScrWidth * ( PicHeight / ScrHeight )
	}

	// 摜̃ItZbgvZ
	UINT uOffsetX;
	UINT uOffsetY;
	uOffsetX	= ( iBmpWidth  - iPictureWidth  ) / 2;
	uOffsetY	= ( iBmpHeight - iPictureHeight ) / 2;


	// bN
	LPBITMAPINFO	pBmpInfo;								// BMPINFO \̂ւ̃|C^
	LPBYTE			pBmpBits;								// rbgzւ̃|C^
	pBmpInfo	= (LPBITMAPINFO)::LocalLock(m_hBmpInfo);
	pBmpBits	= (LPBYTE)::LocalLock(m_hBmpBits);

	// FvZ
	int	iColorDepth;								// J[fvX
	iColorDepth	= m_sPictureInfo.colorDepth;


	// C[W̑傫vZ
	UINT uRasterSize , uImageSize , uRasterHeight;
	uRasterHeight= iBmpHeight;
	uRasterSize	 = ( iBmpWidth * iColorDepth )/8;		// oCg
	uRasterSize += ( 4-(uRasterSize&3) )&3;				// SoCgE
	uImageSize	 = uRasterSize * iBmpHeight;			// đŜ̃TCY

	UINT	uPictureRasterSize;
	uPictureRasterSize  = ( iPictureWidth * iColorDepth )/8;	// oCg
	uPictureRasterSize += ( 4-(uPictureRasterSize&3) )&3;		// SoCgE

	// C[Ŵ߂̃m
	BYTE*	pImage;
	pImage	= (BYTE*)malloc( uImageSize );
	if( pImage==NULL ){								// ̊mۂɎs
		return FALSE;
	}

	int iRQNum;										// RGBQUAD ̐
	if( iColorDepth<=8 )iRQNum	= 1<<iColorDepth;
	else	iRQNum	= 0;


	// wb_
	BITMAPFILEHEADER	bmfh;
	BITMAPINFOHEADER	bmih;

	// BMPFILEHEADER ̍\z
	bmfh.bfType			= 0x4D42;
	bmfh.bfSize			= sizeof( BITMAPFILEHEADER )
						+ sizeof( BITMAPINFOHEADER )
						+ ( sizeof( RGBQUAD ) * iRQNum )
						+ uImageSize;
	bmfh.bfReserved1	= 0;
	bmfh.bfReserved2	= 0;
	bmfh.bfOffBits		= sizeof( BITMAPFILEHEADER )
						+ sizeof( BITMAPINFOHEADER )
						+ ( sizeof( RGBQUAD ) * iRQNum );

	// BMPINFOHEADER ̍\z
	bmih.biSize			= sizeof( BITMAPINFOHEADER );
	bmih.biWidth		= iBmpWidth;
	bmih.biHeight		= iBmpHeight;
	bmih.biPlanes		= pBmpInfo->bmiHeader.biPlanes;
	bmih.biBitCount		= pBmpInfo->bmiHeader.biBitCount;
	bmih.biCompression	= pBmpInfo->bmiHeader.biCompression;
	bmih.biSizeImage	= uImageSize;
	bmih.biXPelsPerMeter= pBmpInfo->bmiHeader.biXPelsPerMeter;
	bmih.biYPelsPerMeter= pBmpInfo->bmiHeader.biYPelsPerMeter;
	bmih.biClrUsed		= pBmpInfo->bmiHeader.biClrUsed;
	bmih.biClrImportant	= pBmpInfo->bmiHeader.biClrImportant;

	// 摜̍č\z
	UINT x,y;
	BYTE* pSrc , *pDest;
	pSrc	= pBmpBits;									// ǂݍ݂
	pDest	= pImage;									// ʐ

	for( y=0;y<uOffsetY;y++ ){							// ̃ItZbg
		for( x=0;x<uRasterSize;x++ ){
			*pDest++ = 0;
		}
	}

	for( y=0;y<(UINT)iPictureHeight;y++ ){				// 摜
		for( x=0;x<(uOffsetX*iColorDepth)/8;x++ ){						// ̃ItZbg
			*pDest++ = 0;
		}
		for( x=0;x<uPictureRasterSize;x++ ){			// 摜
			*pDest++ = *pSrc++;
		}
		for( x=0;x<uRasterSize-uPictureRasterSize-((uOffsetX*iColorDepth)/8);x++ ){	// ẼItZbg
			*pDest++ = 0;
		}
	}

	for( y=0;y<uRasterHeight-iPictureHeight-uOffsetY;y++ ){	// ̃ItZbg
		for( x=0;x<uRasterSize;x++ ){
			*pDest++ = 0;
		}
	}

	// 摜̃Z[u
	FILE*	pStream;
	pStream	= fopen( pFName , "wb" );
	if( pStream==NULL ){
		LocalUnlock( m_hBmpInfo );
		LocalUnlock( m_hBmpBits );
		free( pImage );
		return FALSE;
	}

	fwrite( &bmfh , sizeof( BITMAPFILEHEADER ) , 1 , pStream );
	fwrite( &bmih , sizeof( BITMAPINFOHEADER ) , 1 , pStream );
	if( iRQNum!=0 ){
		fwrite( pBmpInfo->bmiColors  , sizeof( RGBQUAD ) * iRQNum , 1 , pStream );
	}
	fwrite( pImage               , uImageSize                 , 1 , pStream );
	fclose( pStream );

	LocalUnlock( m_hBmpInfo );
	LocalUnlock( m_hBmpBits );
	free( pImage );

	// I
	return TRUE;
}
